/*
	\[X		evalute.c
	ȏ		]֐
	CN[h
	ΉOS			Microsoft-Windows XP/Linux
	ΉCPU			Pentium4ȏ
	RpC		MinGW/gcc/icc
	vWFNg	Makefile
				mssvWFNg
				Oca
	a			Feb 18 2010/Dec 21 2008
*/

#ifdef	_WIN32
#include	<windows.h>
#endif
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>
#include	<assert.h>
#include	"defines.h"
#include	"mss.h"

//#define	MATERIAL_ONLY					// ̂ݕ]֐

#define	MAX_EHASH_SIZE	0x200000		// ]֐nbVTCY(2MGg)
#define	EHASH_MASK	(MAX_EHASH_SIZE-1)	// ]֐nbV}XN

BOOL	LearnMode=FALSE;				// wK[h

struct EHASH_TAG {		// ]֐nbV\(8byte)
	DWORD		key;			// nbVL[
	int			score;			// ǖʂ̕]l
};

typedef	struct EHASH_TAG	EHASH;

//	 (Dec 29 16:33:26 2010 wK)
//							 		j	     	p		     		 \  S  R  n   
int	PieceValue[P_N_HISH+1]={0,128, 473, 552, 690, 765, 920,1017,9999, 843, 712, 762, 736, 0,1161,1236};

// ̂߂̋le[u
int		piece_value[P_N_HISH+1];			// l
int		promote_value[P_HISH+1];			// l
int		mvv_lva[P_N_HISH+1][P_N_HISH+1];	// MVV/LVA

// ̂߂̍We[u
const int	position_tbl[81]={	0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,
								0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,
								0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,
								0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,
								0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,
								0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,
								0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,
								0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,
								0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99
};

static int	OffensePos[81][9][81];		// jpn̈ʒu\()
static int	DefensePos[81][9][81];		// jpn̈ʒu\()

static int	Mobility[6][9];				// Uߋ̓(Ԃ̑O//,p,jn,̃obN)

static int	PinPieceValue[16][7];		// sƉƂ̋
static int	PinAttacks[4][3];			// s̗̍

static int	KingAttacks[13][9];			// ʂ̗̎͂(,2i2,ւ̗)
static int	KingSpace[9];				// ʂ̎Rx()
static int	KingSpace2[9];				// ʂ̎Rx(2i2)

static int	AttackKei;					// j̗_
static int	AttackKaku;					// p̗_

static int	KingGuard[9];				// ʂ̎͂̋

static int	HandValue[8][8];			// ̉l

static EHASH	ehash_tbl[MAX_EHASH_SIZE+1];	// ]֐nbV\

static int		piece_pos(int turn, int piece, int pos, int king1, int king0);	// ʒuɂ_
static BOOL		eval_hash_probe(TRUNK *p, int *score);						// nbVGgT
static void		eval_hash_store(TRUNK *p, int score);						// nbVۑ


#define	loop(x,end_n)\
	p=(x);\
	for ( n=0; n < (end_n); n++ ) {\
	double	d;\
		fread(&d,sizeof(double),1,fp);\
		*p++=(int)d;\
	}


void
InitEvalute(BOOL read_weight)
/*------------------------------------------------------------------------
	]֐̏
	߂l	Ȃ
		no_read		TRUE:d݃f[^ǂ܂Ȃ
		d݂̃f[^ǂݍ/l̏
		2/06/10	ŏ̃o[W
------------------------------------------------------------------------*/
{
int		*p;
int 	n, m;
FILE	*fp;

	if ( read_weight == READ_WEIGHT ) {
		// *** d݃f[^ǂݍ
		if ( (fp=fopen(WEIGHT_FILE,"rb")) == NULL ) {
			fputs(WEIGHT_FILE " read error.",stderr);
		}
		else {
		long long	t_end;

			loop((int *)OffensePos,81*9*81);	// OffensePos
			loop((int *)DefensePos,81*9*81);	// DefensePos

			loop((int *)Mobility,6*9);			// Mobility

			loop((int *)PinPieceValue,16*7);	// PinPieceValue
			loop((int *)PinAttacks,4*3);		// PinAttacks

			loop((int *)KingAttacks,13*9);		// KingAttacks
			loop(KingSpace,9);					// KingSpace
			loop(KingSpace2,9);					// KingSpace2

			loop(&AttackKei,1);					// AttackKei
			loop(&AttackKaku,1);				// AttackKaku

			loop(KingGuard,9);					// KingGuard

			loop((int *)HandValue,8*8);			// HandValue

			fseek(fp,-(int)sizeof(t_end),SEEK_END);
			fread(&t_end,sizeof(t_end),1,fp);

			lprintf(WEIGHT_FILE " %s",ctime((time_t *)&t_end));

			fclose(fp);
		}
	}

	// *** l̏ (quiescenceŎgp)
	for ( n=P_FU; n <= P_HISH; n++ ) {		// `
		if ( n != P_KIN ) continue;		// ͐Ȃ
		promote_value[n]=PieceValue[n|PROMOTE]-PieceValue[n];
	}

	// *** l̏ (quiescenceŎgp)
	for ( n=P_FU; n <= P_N_HISH; n++ ) {		// `
		piece_value[n]=PieceValue[n]+PieceValue[PIECE_ORG_TYPE(n)];
	}

	// *** MVV/LVA (quiescence.c/generate.cŎgp)
	for ( n=P_FU; n <= P_N_HISH; n++ ) {		// `
		for ( m=P_FU; m <= P_N_HISH; m++ ) {	// `
			mvv_lva[n][m]=PieceValue[n]-PieceValue[m]/16;	// -ɍs
		}
	}
}


int
Evalute(TRUNK *p)
/*------------------------------------------------------------------------
	]֐
	߂l	Ȃ
		p		ǖʂ̃|C^
		ՂȂ߂
		5/05/10	Sʏ
			2/11/11	IՂ̕ύX
			4/15	IՕ]֐̕ύX
------------------------------------------------------------------------*/
{
int		piece, i, n, t, score;
int		king1, king0;											// ʂ̈ʒu
int		k1_x, k1_y, k0_x, k0_y;									// ʂ̒i
int		kyo1, kei1, gin1, kaku1, hish1;							// mobility̋
int		kyo0, kei0, gin0, kaku0, hish0;							// mobility̋
int		mobility1[11], mobility0[11];							// Uߋ̓
int		cnt1[14], cnt0[14];										// ʂ̗̎͂̐
int		pin_attacks1[4], pin_attacks0[4];						// s̗̍
int		sg1=0, sg0=0;											// ʂ̎͂̋
int		kei_a1=1, kei_a0=1, kaku_a1=1, kaku_a0=1;				// j,p̗
int		d_king1, d_king0;										// ʂƂ̋

#ifdef	MATERIAL_ONLY			// ̂
	score=0;

	for ( i=0; i < 81; i++ ) {	// ՂȂ߂
	int	pos=position_tbl[i];
	int	tmp;

		piece=p->board[pos];
		tmp=PIECE_TYPE(piece);

		// *** ƈʒu̕]
		if ( piece & B_BIT ) {			// ̋
			if ( tmp != P_OU ) {	// ȊO
				score+=PieceValue[tmp];		// Տ̋̉l
			}
		}
		else if ( piece & W_BIT ) {		// ̋
			if ( tmp != P_OU ) {	// ȊO
				score-=PieceValue[tmp];		// Տ̋̉l
			}
		}
	}

	// *** ̉l
	score+=(PieceValue[P_FU]*(p->hand[1][P_FU]-p->hand[0][P_FU]));
	for ( n=P_KYO; n <= P_HISH; n++ ) {
		score+=(PieceValue[n]*(p->hand[1][n]-p->hand[0][n]));
	}

	return score;
#endif

	if ( !LearnMode && eval_hash_probe(p,&score) ) return score;		// nbṼXRAg

	score=0;

	memset(mobility1,0,sizeof(mobility1));	// 
	memset(mobility0,0,sizeof(mobility0));
	memset(cnt1,0,sizeof(cnt1));
	memset(cnt0,0,sizeof(cnt0));
	memset(pin_attacks1,0,sizeof(pin_attacks1));
	memset(pin_attacks0,0,sizeof(pin_attacks0));
	kyo1=kyo0=kei1=kei0=gin1=gin0=kaku1=kaku0=hish1=hish0=0;

	// ʂ̈ʒu
	king1=p->king[1];
	king0=p->king[0];
	k1_x=LOCATE_X(king1);
	k1_y=LOCATE_Y(king1);
	k0_x=LOCATE_X(king0);
	k0_y=LOCATE_Y(king0);

//lprintf("king1:%02x king0:%02x\n",king1,king0);

	for ( i=0; i < 81; i++ ) {	// ՂȂ߂
	int	pos=position_tbl[i];
	int	x=pos>>4, y=pos&0xf;
	int	tmp;
	int	diff, xx1, yy1, xx0, yy0;
	int	attack1=p->attack[1][pos];
	int	attack0=p->attack[0][pos];

		piece=p->board[pos];
		tmp=PIECE_TYPE(piece);

		// ʂ̋
		xx1=abs(k1_x-x);
		yy1=abs(k1_y-y);
		d_king1=max(xx1,yy1);
		xx0=abs(k0_x-x);
		yy0=abs(k0_y-y);
		d_king0=max(xx0,yy0);

		// *** ƈʒu̕]
		if ( piece & B_BIT ) {			// ̋
			if ( tmp != P_OU ) {	// ȊO
				score+=PieceValue[tmp];		// Տ̋̉l
				score+=piece_pos(BLACK,tmp,pos,king1,king0);	// ʒu
			}

			if ( tmp == P_KYO ) kyo1++;
			else if ( tmp == P_KEI ) {
				kei1++;
				if ( !p->attack[1][pos-1] ) kei_a1=0;	// j̗
			}
			else if ( tmp == P_GIN ) {
				gin1++;
				if ( (xx1 <= 3) && (yy1 <= 1) ) sg1++;
			}
			else if ( tmp == P_KIN ) {
				if ( (xx1 <= 3) && (yy1 <= 1) ) sg1++;
			}
			else if ( tmp == P_KAKU ) {
				kaku1++;
				if ( !p->attack[1][pos-1] ) kaku_a1=0;	// p̗
			}
			else if ( tmp == P_N_KAKU ) kaku1++;
			else if ( (tmp == P_HISH) || (tmp == P_N_HISH) ) hish1++;
		}
		else if ( piece & W_BIT ) {		// ̋
			if ( tmp != P_OU ) {	// ȊO
				score-=PieceValue[tmp];		// Տ̋̉l
				score-=piece_pos(WHITE,tmp,pos,king1,king0);	// ʒu
			}

			if ( tmp == P_KYO ) kyo0++;
			else if ( tmp == P_KEI ) {
				kei0++;
				if ( !p->attack[0][pos+1] ) kei_a0=0;	// j̗
			}
			else if ( tmp == P_GIN ) {
				gin0++;
				if ( (xx0 <= 3) && (yy0 <= 1) ) sg0++;
			}
			else if ( tmp == P_KIN ) {
				if ( (xx0 <= 3) && (yy0 <= 1) ) sg0++;
			}
			else if ( tmp == P_KAKU ) {
				kaku0++;
				if ( !p->attack[0][pos+1] ) kaku_a0=0;	// p̗
			}
			else if ( tmp == P_N_KAKU ) kaku0++;
			else if ( (tmp == P_HISH) || (tmp == P_N_HISH) ) hish0++;
		}

		// *** Uߋ̗Ƃ̈ʒű̕]
		if ( attack1 ) {
		int	n, a=attack1>>TOBI_SHFT;

			for ( n=0; n < 10; n++, a>>=1 ) {	// ї/jn̗
				if ( a & 1 ) {
					if ( !(piece & B_BIT) ) {	// ̋łȂ
						mobility1[n]++;		// Uߋ̓鐔
					}
				}
			}

			// ̃obN
			if ( (attack1 & DIR_NU_MIGI) && !(piece & B_BIT) ) {
				if ( p->board[pos+0x0f] == (B_BIT|P_GIN) ) {
//					lprintf("B %02x\n",pos);
					mobility1[10]++;
				}
			}
			if ( (attack1 & DIR_NU_HIDARI) && !(piece & B_BIT) ) {
				if ( p->board[pos-0x11] == (B_BIT|P_GIN) ) {
//					lprintf("B %02x\n",pos);
					mobility1[10]++;
				}
			}
		}

		if ( attack0 ) {
		int	a=attack0>>TOBI_SHFT;

			for ( n=0; n < 10; n++, a>>=1 ) {	// ї/jn̗
				if ( a & 1 ) {
					if ( !(piece & W_BIT) ) {	// ̋łȂ
						mobility0[n]++;		// Uߋ̓鐔
					}
				}
			}

			// ̃obN
			if ( (attack0 & DIR_NU_MIGI) && !(piece & W_BIT) ) {
				if ( p->board[pos-0x0f] == (W_BIT|P_GIN) ) {
//					lprintf("W %02x\n",pos);
					mobility0[10]++;
				}
			}
			if ( (attack0 & DIR_NU_HIDARI) && !(piece & W_BIT) ) {
				if ( p->board[pos+0x11] == (W_BIT|P_GIN) ) {
//					lprintf("W %02x\n",pos);
					mobility0[10]++;
				}
			}
		}

		// *** ̎͂̕]()
		diff=get_ncnt(attack1)-get_ncnt(attack0);	// ̍

		if ( d_king1 == 1 ) {		// 
			if ( diff < 0 ) {		// ŕĂ
				if ( piece & B_BIT ) cnt1[0]++;			// ̋L
				else if ( tmp == P_EMP ) cnt1[1]++;		// Ȃ
//printf("B0 %02x\n",pos);
			}
			else if ( diff == 0 ) {		// 
				if ( piece & B_BIT ) cnt1[2]++;			// ̋L
				else if ( tmp == P_EMP ) cnt1[3]++;		// Ȃ
//printf("B2 %02x\n",pos);
			}
			else if ( diff > 0 ) {		// Ă
				if ( piece & B_BIT ) cnt1[4]++;			// ̋L
				else if ( tmp == P_EMP ) cnt1[5]++;		// Ȃ
//printf("B4 %02x\n",pos);
			}

			if ( !attack0 && (tmp == P_EMP) ) {		// ̎Rx1
//printf("B13 %02x\n",pos);
				cnt1[13]++;
			}
		}
		else if ( d_king1 == 2 ) {	// 22i
			if ( diff < 0 ) {		// ŕĂ
				if ( piece & B_BIT ) cnt1[6]++;			// ̋L
				else if ( tmp == P_EMP ) cnt1[7]++;		// Ȃ
//printf("B6 %02x\n",pos);
			}
			else if ( diff == 0 ) {		// 
				if ( piece & B_BIT ) cnt1[8]++;			// ̋L
				else if ( tmp == P_EMP ) cnt1[9]++;		// Ȃ
//printf("B8 %02x\n",pos);
			}
			else if ( diff > 0 ) {		// Ă
				if ( piece & B_BIT ) cnt1[10]++;		// ̋L
				else if ( tmp == P_EMP ) cnt1[11]++;	// Ȃ
//printf("B10 %02x\n",pos);
			}

			if ( !attack0 && (tmp == P_EMP) ) {		// ̎Rx2
//printf("B13 %02x\n",pos);
				cnt1[12]++;
			}
		}

		// *** š_()
		if ( p->pin[1][pos] != DIR_ALL ) {
			score+=PinPieceValue[tmp][d_king1];

			if ( diff < 0 ) {		// ŕĂ
				pin_attacks1[0]++;
			}
			else if ( diff == 0 ) {		// 
				pin_attacks1[1]++;
			}
			else if ( diff == 1 ) {		// 1Ă
				pin_attacks1[2]++;
			}
			else if ( diff > 1 ) {		// 2ȏ㏟Ă
				pin_attacks1[3]++;
			}
		}

		// *** ̎͂̕]()
		diff=get_ncnt(attack0)-get_ncnt(attack1);	// ̍

		if ( d_king0 == 1 ) {		// 
			if ( diff < 0 ) {		// ŕĂ
				if ( piece & W_BIT ) cnt0[0]++;			// L
				else if ( tmp == P_EMP ) cnt0[1]++;		// Ȃ
//printf("W0 %02x\n",pos);
			}
			else if ( diff == 0 ) {		// 
				if ( piece & W_BIT ) cnt0[2]++;			// L
				else if ( tmp == P_EMP ) cnt0[3]++;		// Ȃ
//printf("W2 %02x\n",pos);
			}
			else if ( diff > 0 ) {		// Ă
				if ( piece & W_BIT ) cnt0[4]++;			// L
				else if ( tmp == P_EMP ) cnt0[5]++;		// Ȃ
//printf("W4 %02x\n",pos);
			}

			if ( !attack1 && (tmp == P_EMP) ) {		// ̎Rx1
				cnt0[13]++;
//printf("W13 %02x\n",pos);
			}
		}
		else if ( d_king0 == 2 ) {	// 22i
			if ( diff < 0 ) {		// ŕĂ
				if ( piece & W_BIT ) cnt0[6]++;			// L
				else if ( tmp == P_EMP ) cnt0[7]++;		// Ȃ
//printf("W6 %02x\n",pos);
			}
			else if ( diff == 0 ) {		// 
				if ( piece & W_BIT ) cnt0[8]++;			// L
				else if ( tmp == P_EMP ) cnt0[9]++;	// Ȃ
//printf("W8 %02x\n",pos);
			}
			else if ( diff > 0 ) {		// Ă
				if ( piece & W_BIT ) cnt0[10]++;		// L
				else if ( tmp == P_EMP ) cnt0[11]++;	// Ȃ
//printf("W10 %02x\n",pos);
			}

			if ( !attack1 && (tmp == P_EMP) ) {		// ̎Rx2
				cnt0[12]++;
//printf("W13 %02x\n",pos);
			}
		}

		// *** š_()
		if ( p->pin[0][pos] != DIR_ALL ) {
			score-=PinPieceValue[tmp][d_king0];

			if ( diff < 0 ) {		// ŕĂ
				pin_attacks0[0]++;
			}
			else if ( diff == 0 ) {		// 
				pin_attacks0[1]++;
			}
			else if ( diff == 1 ) {		// 1Ă
				pin_attacks0[2]++;
			}
			else if ( diff > 1 ) {		// 2ȏ㏟Ă
				pin_attacks0[3]++;
			}
		}
	}

//lprintf("%d %d %d %d %d %d %d %d %d %d\n",mobility1[0],mobility1[1],mobility1[2],mobility1[3],mobility1[4],mobility1[5],mobility1[6],mobility1[7],mobility1[8],mobility1[9],mobility1[10]);
//lprintf("%d %d %d %d %d %d %d %d %d %d\n",mobility0[0],mobility0[1],mobility0[2],mobility0[3],mobility0[4],mobility0[5],mobility0[6],mobility0[7],mobility0[8],mobility0[9],mobility0[10]);
//lprintf("cnt1 %d %d %d %d %d %d %d %d %d\n",cnt1[0],cnt1[1],cnt1[2],cnt1[3],cnt1[4],cnt1[5],cnt1[6],cnt1[7],cnt1[8]);
//lprintf("cnt0 %d %d %d %d %d %d %d %d %d\n",cnt0[0],cnt0[1],cnt0[2],cnt0[3],cnt0[4],cnt0[5],cnt0[6],cnt0[7],cnt0[8]);

// *** Uߋ̓
	if ( kyo1 || hish1 ) {
		score+=Mobility[0][mobility1[0]/(kyo1+hish1)];					// EO
	}
	if ( hish1 ) {
		score+=Mobility[1][mobility1[1]/hish1];							// 
		score+=Mobility[2][(mobility1[2]+mobility1[3])/hish1];			// 
	}
	if ( kaku1 ) {														// p
		t=(mobility1[4]+mobility1[5]+mobility1[6]+mobility1[7])/kaku1;
		score+=Mobility[3][min(t,8)];
	}
	if ( kei1 ) score+=Mobility[4][(mobility1[8]+mobility1[9])/kei1];	// jn
	if ( gin1 ) score+=Mobility[5][mobility1[10]/gin1];					// 

	if ( kyo0 || hish0 ) {
		score-=Mobility[0][mobility0[0]/(kyo0+hish0)];					// EO
	}
	if ( hish0 ) {
		score-=Mobility[1][mobility0[1]/hish0];							// 
		score-=Mobility[2][(mobility0[2]+mobility0[3])/hish0];			// 
	}
	if ( kaku0 ) {														// p
		t=(mobility0[4]+mobility0[5]+mobility0[6]+mobility0[7])/kaku0;
		score-=Mobility[3][min(t,8)];
	}
	if ( kei0 ) score-=Mobility[4][(mobility0[8]+mobility0[9])/kei0];	// jn
	if ( gin0 ) score-=Mobility[5][mobility0[10]/gin0];					// 

	// *** ̎͂̋
	score+=KingGuard[sg1];
	score-=KingGuard[sg0];

	// *** ̉l
	n=p->hand[1][P_FU];
	score+=(PieceValue[P_FU]*n+HandValue[P_FU][min(n,7)]);
	n=p->hand[0][P_FU];
	score-=(PieceValue[P_FU]*n+HandValue[P_FU][min(n,7)]);
	for ( n=P_KYO; n <= P_HISH; n++ ) {
	int	i;

		i=p->hand[1][n];
		score+=(PieceValue[n]*i+HandValue[n][i]);
		i=p->hand[0][n];
		score-=(PieceValue[n]*i+HandValue[n][i]);
	}

	if ( kei_a1 ) score+=AttackKei;		// *** j,p̗̉_
	if ( kei_a0 ) score-=AttackKei;
	if ( kaku_a1 ) score+=AttackKaku;
	if ( kaku_a0 ) score-=AttackKaku;

	for ( n=6; n <= 13; n++ ) {		// *** ̎͗̕]
		if ( cnt1[n] > 8 ) cnt1[n]=8;
		if ( cnt0[n] > 8 ) cnt0[n]=8;
	}
	for ( n=0; n < 12; n++ ) {
		score+=KingAttacks[n][cnt1[n]];
		score-=KingAttacks[n][cnt0[n]];
	}

	for ( n=0; n < 4; n++ ) {		// *** s̗̍
	int	i;

		i=pin_attacks1[n];
		if ( i ) {
			i--;
			score+=PinAttacks[n][min(i,2)];
		}

		i=pin_attacks0[n];
		if ( i ) {
			i--;
			score-=PinAttacks[n][min(i,2)];
		}
	}

	if ( Grade == ENDING ) {
		// *** ̎Rx
		score+=KingSpace[cnt1[13]];
		score-=KingSpace[cnt0[13]];

		// *** ̎Rx2
		score+=KingSpace2[cnt1[12]];
		score-=KingSpace2[cnt0[12]];

		// *** ւ̗
		n=get_ncnt(p->attack[1][king1]);
		score+=KingAttacks[12][min(n,8)];
		n=get_ncnt(p->attack[0][king0]);
		score-=KingAttacks[12][min(n,8)];
	}

	if ( !LearnMode ) eval_hash_store(p,score);		// ]lnbVe[uɕۑ

	return score;
}


int
piece_pos(int turn, int piece, int pos, int king1, int king0)
/*------------------------------------------------------------------------
	Ƌʒu̕]
	߂l	]l
		p	ǖʂ̃|C^
		Տ̋Ǝ̕]l
		1/25/09 ŏ̃o[W
			1/29/11 DefensePos1̃oOC
------------------------------------------------------------------------*/
{
const int	tbl[]={		// ̕\
//				j			p					\	S		n	
	9,	0,	1,	2,	3,	4,	5,	6,	9,	4,	4,	4,	4,	9,	7,	8};
int	k1, k0, t;

	if ( turn ) {		// Ԃ̍Wϊ
		k1=king1-0x11;
		k0=king0-0x11;
		pos=pos-0x11;
	}
	else {				// Ԃ̍Wϊ
		k1=0x99-king0;
		k0=0x99-king1;
		pos=0x99-pos;
	}

	pos=HEX2NONA(pos);		// hex9i
	k1=HEX2NONA(k1);
	k0=HEX2NONA(k0);
	t=tbl[piece];

	assert((pos >= 0) && (pos <= 80));
	assert((t >= 0) && (t <= 8));

	return OffensePos[k0][t][pos]+DefensePos[k1][t][pos];
}


int
get_ncnt(int cnt)
/*------------------------------------------------------------------------
	̐𒲂ׂ
	߂l	̐
		
		rbg𐔂
		2/25/09 ŏ̃o[W
------------------------------------------------------------------------*/
{
register int	n;

	for ( n=0; cnt; cnt &= (cnt-1) ) n++;

	return n;
}


int
distance(int pos1, int pos2)
/*------------------------------------------------------------------------
	2_̋𒲂ׂ
	߂l	}X
		pos1, pos2	2_̍W
		x,yԂ
		5/05/10 ŏ̃o[W
------------------------------------------------------------------------*/
{
register int	d, x, y;

	d=abs(pos1-pos2);
	x=d >> 4;
	y=d & 0x0f;

	return max(x,y);
}


void
EvaluteHashClear()
/*------------------------------------------------------------------------
	]֐nbV\̏
	߂l	Ȃ
		Ȃ
		eval_hash_tbl0Ŗ߂
		03/16/12	ŏ̃o[W
------------------------------------------------------------------------*/
{
	memset(ehash_tbl,0,sizeof(ehash_tbl));
	profile.eval_hash_use=profile.eval_hash_hits=0;
}


BOOL
eval_hash_probe(TRUNK *p, int *score)
/*------------------------------------------------------------------------
	nbVGgT
	߂l				TRUE:nbVqbg
		p			ǖʂ̃|C^
			score		XRAԂ
		nbVlv|C^Ԃ
		03/16/12	ŏ̃o[W
------------------------------------------------------------------------*/
{
EHASH	*h;		// nbṼ|C^

	h=ehash_tbl+((DWORD)p->hash_val & EHASH_MASK);
	if ( h->key == (DWORD)(p->hash_val>>32) ) {		// ǖʈv
		profile.eval_hash_hits++;	// nbVQƉ

		*score=h->score;
		return TRUE;
	}

	return FALSE;
}


void
eval_hash_store(TRUNK *p, int score)
/*------------------------------------------------------------------------
	nbVۑ
	߂l	Ȃ
		turn		:1
			p			ǖʂ̃|C^
			score		XRA
		nbVƃXRAۑ
		03/16/12	ŏ̃o[W
------------------------------------------------------------------------*/
{
EHASH	*h;		// nbṼ|C^

	profile.eval_hash_use++;	// nbVۑ

	h=ehash_tbl+((DWORD)p->hash_val & EHASH_MASK);

	h->key=p->hash_val>>32;
	h->score=score;
}
