/*
	\[X		feature.c
	ȏ		ʃ[`
	CN[h
	IuWFNg	learn
	ΉOS			Linux
	ΉCPU			Pentium4ȏ(SSE2Kv)
	RpC		gcc
	vWFNg	Makefile
				mssvWFNg
				Oca
	a			Jun 19 2010
*/

#ifdef	_WIN32
#include	<windows.h>
#endif
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>
#include	<assert.h>
#include	"defines.h"
#include	"mss.h"
#include	"feature.h"

static int	king1, king0;			// ʂ̈ʒu
static int	d_king1, d_king0;		// ʂƂ̋

static void		piece_pos1(int piece, int pos, FEATURE *f);	// Ƌʒu̕]()
static void		piece_pos0(int piece, int pos, FEATURE *f);	// Ƌʒu̕]()


void
feature_extract(TRUNK *p, FEATURE *f)
/*------------------------------------------------------------------------
	ʂ𒊏o
	߂l	Ȃ
		*p		ǖʂ̃|C^
			*f		ʂ̃|C^
	
		6/19/10	ŏ̃o[W
			2/11/11 IՂ̕ύX
------------------------------------------------------------------------*/
{
int		piece, t, i, n;
int		k1_x, k1_y, k0_x, k0_y;
int		kyo1, kei1, gin1, kaku1, hish1;							// mobility̋
int		kyo0, kei0, gin0, kaku0, hish0;							// mobility̋
int		mobility1[11], mobility0[11];							// Uߋ̓
int		cnt1[14], cnt0[14];										// ʂ̗̎͂̐
int		sg1=0, sg0=0;											// ʂ̎͂̋
int		pin_attacks1[4], pin_attacks0[4];						// s̗̍
int		kei_a1=1, kei_a0=1, kaku_a1=1, kaku_a0=1;				// j,p̗

	memset(mobility1,0,sizeof(mobility1));	// 
	memset(mobility0,0,sizeof(mobility0));
	memset(cnt1,0,sizeof(cnt1));
	memset(cnt0,0,sizeof(cnt0));
	memset(pin_attacks1,0,sizeof(pin_attacks1));
	memset(pin_attacks0,0,sizeof(pin_attacks0));
	kyo1=kyo0=kei1=kei0=gin1=gin0=kaku1=kaku0=hish1=hish0=0;

	// ʂ̈ʒu
	king1=p->king[1];
	king0=p->king[0];
	k1_x=LOCATE_X(king1);
	k1_y=LOCATE_Y(king1);
	k0_x=LOCATE_X(king0);
	k0_y=LOCATE_Y(king0);

	for ( i=0; i < 81; i++ ) {	// ՂȂ߂
	int	pos=position_tbl[i];
	int	x=pos>>4, y=pos&0xf;
	int	tmp;
	int	diff, xx1, yy1, xx0, yy0;
	int	attack1=p->attack[1][pos];
	int	attack0=p->attack[0][pos];

		piece=p->board[pos];
		tmp=PIECE_TYPE(piece);

		// ʂ̋
		xx1=abs(k1_x-x);
		yy1=abs(k1_y-y);
		d_king1=max(xx1,yy1);
		xx0=abs(k0_x-x);
		yy0=abs(k0_y-y);
		d_king0=max(xx0,yy0);

		if ( piece & B_BIT ) {			// ̋
			if ( tmp != P_OU ) {	// ȊO
				piece_pos1(tmp,pos,f);		// ʒu
			}

			if ( tmp == P_KYO ) kyo1++;
			else if ( tmp == P_KEI ) {
				kei1++;
				if ( !p->attack[1][pos-1] ) kei_a1=0;	// j̗
			}
			else if ( tmp == P_GIN ) {
				gin1++;
				if ( (xx1 <= 3) && (yy1 <= 1) ) sg1++;
			}
			else if ( tmp == P_KIN ) {
				if ( (xx1 <= 3) && (yy1 <= 1) ) sg1++;
			}
			else if ( tmp == P_KAKU ) {
				kaku1++;
				if ( !p->attack[1][pos-1] ) kaku_a1=0;	// p̗
			}
			else if ( tmp == P_N_KAKU ) kaku1++;
			else if ( (tmp == P_HISH) || (tmp == P_N_HISH) ) hish1++;
		}
		else if ( piece & W_BIT ) {		// ̋
			if ( tmp != P_OU ) {	// ȊO
				piece_pos0(tmp,pos,f);		// ʒu
			}

			if ( tmp == P_KYO ) kyo0++;
			else if ( tmp == P_KEI ) {
				kei0++;
				if ( !p->attack[0][pos+1] ) kei_a0=0;	// j̗
			}
			else if ( tmp == P_GIN ) {
				gin0++;
				if ( (xx0 <= 3) && (yy0 <= 1) ) sg0++;
			}
			else if ( tmp == P_KIN ) {
				if ( (xx0 <= 3) && (yy0 <= 1) ) sg0++;
			}
			else if ( tmp == P_KAKU ) {
				kaku0++;
				if ( !p->attack[0][pos+1] ) kaku_a0=0;	// p̗
			}
			else if ( tmp == P_N_KAKU ) kaku0++;
			else if ( (tmp == P_HISH) || (tmp == P_N_HISH) ) hish0++;
		}

		if ( attack1 ) {
		int	n, a=attack1>>TOBI_SHFT;

			for ( n=0; n < 10; n++, a>>=1 ) {	// ї/jn̗
				if ( a & 1 ) {
					if ( !(piece & B_BIT) ) {	// ̋
						mobility1[n]++;		// Uߋ̓鐔
					}
				}
			}

			// ̃obN
			if ( (attack1 & DIR_NU_MIGI) && !(piece & B_BIT) ) {
				if ( p->board[pos+0x0f] == (B_BIT|P_GIN) ) {
//					printf("B %02x\n",pos);
					mobility1[10]++;
				}
			}
			if ( (attack1 & DIR_NU_HIDARI) && !(piece & B_BIT)	) {
				if ( p->board[pos-0x11] == (B_BIT|P_GIN) ) {
//					printf("B %02x\n",pos);
					mobility1[10]++;
				}
			}
		}

		if ( attack0 ) {
		int	n, a=attack0>>TOBI_SHFT;

			for ( n=0; n < 10; n++, a>>=1 ) {	// ї/jn̗
				if ( a & 1 ) {
					if ( !(piece & W_BIT) ) {	// ̋
						mobility0[n]++;		// Uߋ̓鐔
					}
				}
			}

			// ̃obN
			if ( (attack0 & DIR_NU_MIGI) && !(piece & W_BIT) ) {
				if ( p->board[pos-0x0f] == (W_BIT|P_GIN) ) {
//					printf("B %02x\n",pos);
					mobility0[10]++;
				}
			}
			if ( (attack0 & DIR_NU_HIDARI) && !(piece & W_BIT)	) {
				if ( p->board[pos+0x11] == (W_BIT|P_GIN) ) {
//					printf("B %02x\n",pos);
					mobility0[10]++;
				}
			}
		}

		// *** ̎͂̕]()
		diff=get_ncnt(attack1)-get_ncnt(attack0);	// ̍

		if ( d_king1 == 1 ) {		// 
			if ( diff < 0 ) {		// ŕĂ
				if ( piece & B_BIT ) cnt1[0]++;			// ̋L
				else if ( tmp == P_EMP ) cnt1[1]++;		// Ȃ
//printf("B0 %02x\n",pos);
			}
			else if ( diff == 0 ) {		// 
				if ( piece & B_BIT ) cnt1[2]++;			// ̋L
				else if ( tmp == P_EMP ) cnt1[3]++;		// Ȃ
//printf("B2 %02x\n",pos);
			}
			else if ( diff > 0 ) {		// Ă
				if ( piece & B_BIT ) cnt1[4]++;			// ̋L
				else if ( tmp == P_EMP ) cnt1[5]++;		// Ȃ
//printf("B4 %02x\n",pos);
			}

			if ( !attack0 && (tmp == P_EMP) ) {		// ̎Rx1
//printf("B13 %02x\n",pos);
				cnt1[13]++;
			}
		}
		else if ( d_king1 == 2 ) {	// 22i
			if ( diff < 0 ) {		// ŕĂ
				if ( piece & B_BIT ) cnt1[6]++;			// ̋L
				else if ( tmp == P_EMP ) cnt1[7]++;		// Ȃ
//printf("B6 %02x\n",pos);
			}
			else if ( diff == 0 ) {		// 
				if ( piece & B_BIT ) cnt1[8]++;			// ̋L
				else if ( tmp == P_EMP ) cnt1[9]++;		// Ȃ
//printf("B8 %02x\n",pos);
			}
			else if ( diff > 0 ) {		// Ă
				if ( piece & B_BIT ) cnt1[10]++;		// ̋L
				else if ( tmp == P_EMP ) cnt1[11]++;	// Ȃ
//printf("B10 %02x\n",pos);
			}

			if ( !attack0 && (tmp == P_EMP) ) {		// ̎Rx2
//printf("B13 %02x\n",pos);
				cnt1[12]++;
			}
		}

		// *** š_()
		if ( p->pin[1][pos] != DIR_ALL ) {
			f->PinPieceValue1[tmp][d_king1]=1;

			if ( diff < 0 ) {		// ŕĂ
				pin_attacks1[0]++;
			}
			else if ( diff == 0 ) {		// 
				pin_attacks1[1]++;
			}
			else if ( diff == 1 ) {		// 1Ă
				pin_attacks1[2]++;
			}
			else if ( diff > 1 ) {		// 2ȏ㏟Ă
				pin_attacks1[3]++;
			}
		}

		// *** ̎͂̕]()
		diff=get_ncnt(attack0)-get_ncnt(attack1);	// ̍

		if ( d_king0 == 1 ) {		// 
			if ( diff < 0 ) {		// ŕĂ
				if ( piece & W_BIT ) cnt0[0]++;			// L
				else if ( tmp == P_EMP ) cnt0[1]++;		// Ȃ
//printf("W0 %02x\n",pos);
			}
			else if ( diff == 0 ) {		// 
				if ( piece & W_BIT ) cnt0[2]++;			// L
				else if ( tmp == P_EMP ) cnt0[3]++;		// Ȃ
//printf("W2 %02x\n",pos);
			}
			else if ( diff > 0 ) {		// Ă
				if ( piece & W_BIT ) cnt0[4]++;			// L
				else if ( tmp == P_EMP ) cnt0[5]++;		// Ȃ
//printf("W4 %02x\n",pos);
			}

			if ( !attack1 && (tmp == P_EMP) ) {		// ̎Rx1
				cnt0[13]++;
//printf("W13 %02x\n",pos);
			}
		}
		else if ( d_king0 == 2 ) {	// 22i
			if ( diff < 0 ) {		// ŕĂ
				if ( piece & W_BIT ) cnt0[6]++;			// L
				else if ( tmp == P_EMP ) cnt0[7]++;		// Ȃ
//printf("W6 %02x\n",pos);
			}
			else if ( diff == 0 ) {		// 
				if ( piece & W_BIT ) cnt0[8]++;			// L
				else if ( tmp == P_EMP ) cnt0[9]++;	// Ȃ
//printf("W8 %02x\n",pos);
			}
			else if ( diff > 0 ) {		// Ă
				if ( piece & W_BIT ) cnt0[10]++;		// L
				else if ( tmp == P_EMP ) cnt0[11]++;	// Ȃ
//printf("W10 %02x\n",pos);
			}

			if ( !attack1 && (tmp == P_EMP) ) {		// ̎Rx2
				cnt0[12]++;
//printf("W13 %02x\n",pos);
			}
		}

		// *** š_()
		if ( p->pin[0][pos] != DIR_ALL ) {
			f->PinPieceValue0[tmp][d_king0]=1;

			if ( diff < 0 ) {		// ŕĂ
				pin_attacks0[0]++;
			}
			else if ( diff == 0 ) {		// 
				pin_attacks0[1]++;
			}
			else if ( diff == 1 ) {		// 1Ă
				pin_attacks0[2]++;
			}
			else if ( diff > 1 ) {		// 2ȏ㏟Ă
				pin_attacks0[3]++;
			}
		}
	}

	// *** Uߋ̓
//printf("%d %d %d %d %d %d %d %d %d %d\n",mobility1[0],mobility1[1],mobility1[2],mobility1[3],mobility1[4],mobility1[5],mobility1[6],mobility1[7],mobility1[8],mobility1[9],mobility1[10]);
//printf("%d %d %d %d %d %d %d %d %d %d\n",mobility0[0],mobility0[1],mobility0[2],mobility0[3],mobility0[4],mobility0[5],mobility0[6],mobility0[7],mobility0[8],mobility0[9],mobility0[10]);
	if ( kyo1 || hish1 ) {
		f->Mobility1[0][mobility1[0]/(kyo1+hish1)]=1;					// EO
	}
	if ( hish1 ) {
		f->Mobility1[1][mobility1[1]/hish1]=1;							// 
		f->Mobility1[2][(mobility1[2]+mobility1[3])/hish1]=1;			// 
	}
	if ( kaku1 ) {														// p
		t=(mobility1[4]+mobility1[5]+mobility1[6]+mobility1[7])/kaku1;
		f->Mobility1[3][min(t,8)]=1;
	}
	if ( kei1 ) f->Mobility1[4][(mobility1[8]+mobility1[9])/kei1]=1;	// jn
	if ( gin1 ) f->Mobility1[5][mobility1[10]/gin1]=1;					// 

	if ( kyo0 || hish0 ) {
		f->Mobility0[0][mobility0[0]/(kyo0+hish0)]=1;					// EO
	}
	if ( hish0 ) {
		f->Mobility0[1][mobility0[1]/hish0]=1;							// 
		f->Mobility0[2][(mobility0[2]+mobility0[3])/hish0]=1;			// 
	}
	if ( kaku0 ) {														// p
		t=(mobility0[4]+mobility0[5]+mobility0[6]+mobility0[7])/kaku0;
		f->Mobility0[3][min(t,8)]=1;
	}
	if ( kei0 ) f->Mobility0[4][(mobility0[8]+mobility0[9])/kei0]=1;	// jn
	if ( gin0 ) f->Mobility0[5][mobility0[10]/gin0]=1;					// 

	// *** ̎͂̋
	f->KingGuard1[sg1]=1;
	f->KingGuard0[sg0]=1;

	// *** ̓
	n=p->hand[1][P_FU];
	f->HandValue1[P_FU][min(n,7)]=1;
	n=p->hand[0][P_FU];
	f->HandValue0[P_FU][min(n,7)]=1;

	for ( n=P_KYO; n <= P_HISH; n++ ) {
		f->HandValue1[n][p->hand[1][n]]=1;
		f->HandValue0[n][p->hand[0][n]]=1;
	}

	if ( kei_a1 ) f->AttackKei1=1;		// *** j,p̗̉_
	if ( kei_a0 ) f->AttackKei0=1;
	if ( kaku_a1 ) f->AttackKaku1=1;
	if ( kaku_a0 ) f->AttackKaku0=1;

	for ( n=6; n <= 13; n++ ) {			// *** ̎͗̕]
		if ( cnt1[n] > 8 ) cnt1[n]=8;
		if ( cnt0[n] > 8 ) cnt0[n]=8;
	}

	for ( n=0; n < 12; n++ ) {
		f->KingAttacks1[n][cnt1[n]]=1;
		f->KingAttacks0[n][cnt0[n]]=1;
	}

	for ( n=0; n < 4; n++ ) {		// *** s̗̍
	int	i;

		i=pin_attacks1[n];
		if ( i ) {
			i--;
			f->PinAttacks1[n][min(i,2)]=1;
		}

		i=pin_attacks0[n];
		if ( i ) {
			i--;
			f->PinAttacks0[n][min(i,2)]=1;
		}
	}

	if ( Grade == ENDING ) {
		// *** ̎Rx
		f->KingSpace1[cnt1[13]]=1;
		f->KingSpace0[cnt0[13]]=1;

		// *** ̎Rx2
		f->KingSpace21[cnt1[12]]=1;
		f->KingSpace20[cnt0[12]]=1;

		// *** ւ̗
		n=get_ncnt(p->attack[1][king1]);
		f->KingAttacks1[12][min(n,8)]=1;
		n=get_ncnt(p->attack[0][king0]);
		f->KingAttacks0[12][min(n,8)]=1;
	}
}


int
feature_to_evalute(FEATURE *f, WEIGHT *w)
/*------------------------------------------------------------------------
	ʂ̍ɂ]l
	߂l	Ԃ猩]l
		f		ʂ̍
			w		d
	
		6/20/10 ŏ̃o[W
			1/01/11 ʒuOƂ
------------------------------------------------------------------------*/
{
int		n, m, k;
double	v=0;

#define	function(x)\
	if ( f->x##1[n][m][k] ) {\
		v+=w->x[n][m][k];\
	}\
	if ( f->x##0[n][m][k] ) {\
		v-=w->x[n][m][k];\
	}

	loop_triple(0,81,0,9,0,81,OffensePos);		// OffensePos
	loop_triple(0,81,0,9,0,81,DefensePos);		// DefensePos

#undef	function
#define	function(x)\
	if ( f->x##1[n][m] ) {\
		v+=w->x[n][m];\
	}\
	if ( f->x##0[n][m] ) {\
		v-=w->x[n][m];\
	}

	loop_double(0,6,0,9,Mobility);				// Mobility

	loop_double(1,16,1,7,PinPieceValue);		// PinPieceValue
	loop_double(0,4,0,3,PinAttacks);			// PinAttacks
	loop_double(P_FU,P_HISH+1,0,8,HandValue);	// HandValue
	loop_double(0,13,0,9,KingAttacks);			// KingAttacks

#undef	function
#define	function(x)\
if ( f->x##1[n] ) {\
	v+=w->x[n];\
}\
if ( f->x##0[n] ) {\
	v-=w->x[n];\
}

	loop_single(0,9,KingSpace);			// KingSpace

#undef	function
#define	function(x)\
if ( f->x##1 ) {\
	v+=w->x;\
}\
if ( f->x##0 ) {\
	v-=w->x;\
}

	function(AttackKei);
	function(AttackKaku);

	return (int)((v > 0) ? v+0.5 : v-0.5);		// ľܓ
}


int
evalute_material(TRUNK *p)
/*------------------------------------------------------------------------
	̕]
	߂l	Ԃ猩]l
		*p		ǖʂ̃|C^
	
		1/31/12 ŏ̃o[W
------------------------------------------------------------------------*/
{
int	n, v=0, piece, tmp;

	// *** Տ̋̕]
	for ( n=0; n < 81; n++ ) {	// ՂȂ߂
		piece=p->board[position_tbl[n]];
		tmp=PIECE_TYPE(piece);

		if ( piece & B_BIT ) {			// ̋
			if ( tmp != P_OU ) {	// ȊO
				v+=PieceValue[tmp];	// Տ̋̉l
			}
		}
		else if ( piece & W_BIT ) {		// ̋
			if ( tmp != P_OU ) {	// ȊO
				v-=PieceValue[tmp];	// Տ̋̉l
			}
		}
	}

	// *** ̕]
	v+=(PieceValue[P_FU]*p->hand[1][P_FU]);
	v-=(PieceValue[P_FU]*p->hand[0][P_FU]);

	for ( n=P_KYO; n <= P_HISH; n++ ) {
		v+=(PieceValue[n]*p->hand[1][n]);
		v-=(PieceValue[n]*p->hand[0][n]);
	}

	return v;
}


void
piece_pos1(int piece, int pos, FEATURE *f)
/*------------------------------------------------------------------------
	Ƌʒu̕]()
	߂l	Ȃ
		piece	
			pos		ʒu
			f		ʂ̃xNg
		Տ̋Ǝ̕]l
		1/25/09 ŏ̃o[W
			1/29/11 DefensePos1̃oOC
------------------------------------------------------------------------*/
{
const int	tbl[]={		// ̕\
//				j			p					\	S		n	
	9,	0,	1,	2,	3,	4,	5,	6,	9,	4,	4,	4,	4,	9,	7,	8};
int		k1, k0, t;

	k1=king1-0x11;
	k0=king0-0x11;
	pos=pos-0x11;

	pos=HEX2NONA(pos);		// hex9i
	k1=HEX2NONA(k1);
	k0=HEX2NONA(k0);
	t=tbl[piece];

	assert((pos >= 0) && (pos <= 80));
	assert((t >= 0) && (t <= 8));

	f->OffensePos1[k0][t][pos]=f->DefensePos1[k1][t][pos]=1;
}


void
piece_pos0(int piece, int pos, FEATURE *f)
/*------------------------------------------------------------------------
	Ƌʒu̕]()
	߂l	Ȃ
		piece	
			pos		ʒu
			f		ʂ̃xNg
		Տ̋Ǝ̕]l
		1/25/09 ŏ̃o[W
			1/29/11 DefensePos1̃oOC
------------------------------------------------------------------------*/
{
const int	tbl[]={		// ̕\
//				j			p					\	S		n	
	9,	0,	1,	2,	3,	4,	5,	6,	9,	4,	4,	4,	4,	9,	7,	8};
int		k1, k0, t;

	// W]
	k1=0x99-king0;
	k0=0x99-king1;
	pos=0x99-pos;

	pos=HEX2NONA(pos);		// hex9i
	k1=HEX2NONA(k1);
	k0=HEX2NONA(k0);
	t=tbl[piece];

	assert((pos >= 0) && (pos <= 80));
	assert((t >= 0) && (t <= 8));

	f->OffensePos0[k0][t][pos]=f->DefensePos0[k1][t][pos]=1;
}
