/*
	\[X		root_search.c
	ȏ		[gm[hT
	CN[h
	ΉOS			Microsoft-Windows XP/Linux
	ΉCPU			Pentium4ȏ
	RpC		MinGW/gcc/icc
	vWFNg	Makefile
				mssvWFNg
				Oca
	a			Feb 18 2010/Dec 21 2008
*/

#ifdef	_WIN32
#include	<windows.h>
#include	<process.h>
#else
#include	<pthread.h>
#include	<unistd.h>
#endif
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<assert.h>
#include	"defines.h"
#include	"mss.h"

#define	ASPIRATION_WINDOW

MOVE	KillerMate[MAX_PLY+2];			// L[(l)
MOVE	KillerMove1[MAX_PLY+2];			// L[1
MOVE	KillerMove2[MAX_PLY+2];			// L[2

int		Iterate;						// [T[

BOOL	AbortSearch;					// Tf
BOOL	Extend;							// őP̕]l̂Ŏvl
BOOL	AnalyzeMode;					// /\vl[h
int		RemainTime;						// c莞[s]
int		Countdown;						// bǂ[s]
int		Elapsed;						// oߎ[ms]
int		OnePlyTime;						// 1\莞

struct ROOT_LIST {	// [gm[h̏
	short	cut_score;		// JbgXRA
	short	score;			// XRA
	BYTE	max_ply;		// ǂ݂̐[
	BYTE	max_qui_ply;	// Î~T̐[
	int		nodes;			// m[h
	MOVE	pv[MAX_PLY+1];	// őP̔z
};
static struct ROOT_LIST	root_list[MAX_MOVE];
static MOVE	root_move[MAX_MOVE];			// [g̔z
static int	root_n_move;					// [g@萔

static int	iterate_value[MAX_PLY+1];		// [̃XRA
static BOOL	best_change[MAX_PLY+1];			// [̍őPω
static BOOL	fail_high;						// fail high

static DWORD	it_time;						// [̌oߎ[ms]

static void	root_list_print();				// Tʂ̕\
static int	root_search(int alpha, int beta);	// [gm[h̒T
static int		repetition(TRUNK *p);			// ̃`FbN
static BOOL	entering_king();				// ʏ̃`FbN
static void	sort(MOVE *p_move, struct ROOT_LIST *p_score, int n_move);		// ̕בւ


int
IterativeDeep(MOVE bestmove[2], int max_iterate)
/*------------------------------------------------------------------------
	[T
	߂l	]l
		bestmove[0]	̍őP
			bestmove[1]	̍őP
			max_iterate		ő唽[T[
		nega-max@ōőP𐶐
		12/28/08	ŏ̃o[W
			01/02/10	aspiration window searchǉ
			03/14/12	L[̃NAړ
------------------------------------------------------------------------*/
{
#define	WINDOW_SIZE1	192		// EChE1(1.5̒l)
#define	WINDOW_SIZE2	550		// EChE2(j1̒l)
/*
#define	WINDOW_SIZE1	64		// EChE1(1/4̒l)
#define	WINDOW_SIZE2	512		// EChE2(2̒l)
*/
int		n, score, ret=0;
#ifdef	ASPIRATION_WINDOW
int		alpha=-INF, beta=INF;
int		high_fail, low_fail;
#endif

	root_n_move=GenerateRoot(root_move);		// @萶
	lprintf("[g=%d\n",root_n_move);

/*
	MovePrint(root_move,root_n_move,NULL);	// rooẗꗗ
	lputs("");
*/
	if ( root_n_move == 0 ) return -INF;		// l݂܂

	AbortSearch=Extend=FALSE;

	memset(root_list,0,sizeof(root_list));				// [gm[h̏̏

	memset(profile.avg_cut,0,sizeof(profile.avg_cut));	// σx[^Jbg̏
	memset(profile.order,0,sizeof(profile.order));		// 萶z̏

	memset(HistoryCut,0,sizeof(HistoryCut));			// Relative History Heuristic(cut)
	memset(HistoryTride,0,sizeof(HistoryTride));		// Relative History Heuristic(tried)

	EvaluteHashClear();									// ]֐nbV\̏

	iterate_value[0]=iterate_value[1]=profile.all_moves=0;

	SearchAge++;		// nbṼGgς

	for ( Iterate=1; Iterate <= max_iterate; Iterate++ ) {	// [T
		it_time=GetTickCount();		// ݂̎

#ifdef	ASPIRATION_WINDOW
		if ( (Iterate >= 3) && abs(ret) < 15000 ) {	// [3ȏaspiration window
			alpha=ret-WINDOW_SIZE1;
			beta=ret+WINDOW_SIZE1;
		}
		else {
			alpha=-INF;
			beta=INF;
		}
		high_fail=low_fail=0;

		do {
			profile.nodes=profile.pv_nodes=1;
			profile.non_pv_nodes=profile.qui_nodes=0;

			profile.iid[0]=profile.iid[1]=profile.razoring=profile.null_move=0;
			memset(profile.re_search,0,sizeof(profile.re_search));	// Č̏
			memset(profile.lmr,0,sizeof(profile.lmr));				// LMȐ
			memset(profile.pruning,0,sizeof(profile.pruning));	// Futility̏

			alpha=max(-INF,alpha);	// alpha,beta limit
			beta=min(INF,beta);
			lprintf("\n*** Iterate=%d (alpha:%d beta:%d ret:%d)\n",Iterate,alpha,beta,ret);

			score=root_search(alpha,beta);		// [gm[h̒T

			if ( AbortSearch ) break;	// Tfꂽ

			// aspiration window̔
			if ( (alpha < score) && (score < beta) ) break;	// window͈̔͂ɓĂ
			else if ( score >= beta ) {		// beta͈̔͂ɓĂȂ
				if ( high_fail == 0 ) {
					beta+=WINDOW_SIZE2;		// betaL
					high_fail=1;
				}
				else if ( high_fail == 1 ) beta=INF;	// betaINFɂ

				lprintf("high fail score:%d beta:%d\n",score,beta);
			}
			else if ( score <= alpha ) {	// alpha͈̔͂ɓĂȂ
				if ( low_fail == 0 ) {
					alpha-=WINDOW_SIZE2;	// alphaL
					low_fail=1;
				}
				else if ( low_fail == 1 ) alpha=-INF;	// alpha-INFɂ

				lprintf("low fail score:%d alpha:%d\n",score,alpha);
			}

			sort(root_move,root_list,root_n_move);		// בւ
		} while ( abs(score) < (INF-100) );

#else	// aspiration windowȂ
		lprintf("\n=%d ret=%d\n",Iterate,ret);
		score=root_search(-INF,INF);	// [gm[h̒T
#endif
		if ( AbortSearch ) {		// Tfꂽ
			lprintf(">>> AbortSearch(Elapsed=%d[ms])\n",Elapsed);
			break;
		}

		ret=score;
		iterate_value[Iterate]=score;

		sort(root_move,root_list,root_n_move);	// בւ

		bestmove[0]=root_list[0].pv[0];			// ̍őP
		bestmove[1]=root_list[0].pv[1];			// ̍őP
		MaxPly=root_list[0].max_ply;

		HashStore(BLACK,Trunk,EXACTLY,Iterate*ONE_PLY,ret,bestmove[0]);	// nbV̍XV

		it_time=GetTickCount()-it_time+1;		// vlԌv

		usi_info(it_time,score,root_list[0].pv);	// USI infoR}h
		root_list_print();						// Tʂ̕\

		// [𔲂
		if ( (score == REPETITION) || (score == WIN) ) {	// ,ʏ
			bestmove[1]=0;						// ̍őP
			lprintf(",ʏ score:%d\n",score);
			break;
		}

		if ( score >= (INF-100) ) {		// 
			lprintf(" score=%d\n",score);
			break;
		}
		if ( (Iterate >= 6) && (score <= -(INF-100)) ) {	// 
			lprintf(" score=%d\n",score);
			break;
		}

		if ( !AnalyzeMode ) {		// ʏvl[h
			if ( ((Iterate >= 8) && (root_list[1].cut_score == -INF))
				&& (((root_list[0].nodes > (profile.nodes*87)/100) && (Elapsed > OnePlyTime/10))
				|| ((root_list[0].nodes > (profile.nodes*60)/100) && (Elapsed > OnePlyTime/2))) ) {
					lputs("ł؂");
					break;
			}
		}
	}

	lputs("beta cut av.");		// x[^Jbg(I[_O)
	lprintf("PLY");
	for ( n=1; n < MaxPly; n++ ) lprintf("%5d",n+1);
	lprintf("\nPV   ");
	for ( n=1; n < MaxPly; n++ ) lprintf("%5.1lf",profile.avg_cut[0][n]/10.0);
	lprintf("\nNonPV");
	for ( n=1; n < MaxPly; n++ ) lprintf("%5.1lf",profile.avg_cut[1][n]/10.0);

	lprintf("\n\nAll Moves=%d\n",profile.all_moves);
	if ( !profile.all_moves ) return ret;

	lprintf("HashMove %.3lf(%d) KillerMate %.3lf(%d) Killer1 %.3lf(%d) Killer2 %.3lf(%d)\n",
			profile.order[1]*100.0/profile.all_moves,profile.order[1],
			profile.order[2]*100.0/profile.all_moves,profile.order[2],
			profile.order[3]*100.0/profile.all_moves,profile.order[3],
			profile.order[4]*100.0/profile.all_moves,profile.order[4]);
	lprintf("GOOD CapPro %.2lf(%u) BAD CapPro %.2lf(%u) History %.1lf%% NoHistory %.1lf%% Evasion %.2lf(%u)\n",
			profile.order[5]*100.0/profile.all_moves,profile.order[5],
			profile.order[6]*100.0/profile.all_moves,profile.order[6],
			profile.order[7]*100.0/profile.all_moves,
			profile.order[8]*100.0/profile.all_moves,
			profile.order[0]*100.0/profile.all_moves,profile.order[0]);

	return ret;
}


int
root_search(int alpha, int beta)
/*------------------------------------------------------------------------
	[gm[h̒T
	߂l	]l
		n_move		[g̐
			alpha, beta	,l
		PVSōőPT
		12/31/09	ŏ̃o[W
			01/02/10	PVS֕ύX
			01/03/10	ǖ,̃obt@[ʔzɂ
------------------------------------------------------------------------*/
{
#define	EXTEND_MARGIN		32		// vl[h̃}[W
#define	NO_EXTEND_MARGIN	24		// vl[h߂}[W

int		n, score, nodes_ini;
int		d, ext;
TRUNK	*p=Trunk;				// eǖʂ̃|C^
TRUNK	*copy=Trunk+1;			// qǖʂ̃|C^
MOVE	new_pv[MAX_PLY+1];		// őP̔z

	memset(KillerMove1,0,sizeof(KillerMove1));		// L[̏
	memset(KillerMove2,0,sizeof(KillerMove2));
	memset(KillerMate,0,sizeof(KillerMate));

	p->hash_move=0;									// nbṼNA

	for ( n=0; !AbortSearch && (n < root_n_move); n++ ) {
	int	move=root_move[n];

		MaxPly=MaxQuiPly=0;
		fail_high=FALSE;
		PvClear(new_pv);	// őP̃NA

		nodes_ini=profile.nodes;

		p->eval=0;					// ]l̃NA
		*copy=*p;					// [gǖʂ̃Rs[
		copy->current_mov=move;		// ̃Rs[
		NewBoard(BLACK,move,copy);	// ŐVǖʂ

		score=repetition(copy);		// ̃`FbN
		if ( score ) {
			if ( score == INF ) {		// I
				PvAdd(root_list[0].pv,new_pv,move);		// őP̃Rs[
				return REPETITION;
			}

			if ( (root_n_move != 1) && (score == -INF) ) {	// 
				root_list[n].cut_score=-INF;
				continue;
			}
		}

		if ( entering_king() ) {	// ʏ̃`FbN
			lputs("ʏ");
			PvAdd(root_list[0].pv,new_pv,move);		// őP̃Rs[

			return WIN;
		}

		// *** T
		ext=0;
		if ( copy->attack[BLACK][copy->king[WHITE]] ) {		// 
			if ( (From(move) == 0) && (Piece(move) == P_FU) ) {	// łl߂̃`FbN
				if ( DropFuMate(WHITE,copy) ) {	// łl
					continue;
				}
			}
			else {
				ext=ONE_PLY;
			}
		}
		d=Iterate*ONE_PLY+ext;		// ̒Tւ̎c[(2+Î~Tn܂邱Ƃɒ)

		if ( (n == 0) || (Iterate <= 2) ) {		// [2܂PVm[hT
			score=-SearchPv(WHITE,-beta,-alpha,1,d,new_pv);

			// őP̃XRÂŎvl
			Extend=(Iterate >= 2) && (score <= (iterate_value[Iterate-1]-EXTEND_MARGIN));
#ifdef	FULLDUMP
			printf("0 %02x%s%s(%02x) c=%s s=%d\n",To(move),koma[PIECE_TYPE(Piece(move))],Promote(move)?"":"",From(move),koma[PIECE_TYPE(Capture(move))],score);
#endif
		}
		else {
			score=-SearchNonPv(WHITE,-alpha,1,d,TRUE,new_pv);	// ZWS

			if ( (score > alpha) && (score < beta) ) {	// ZWSŝ߃EChE߂čĒT
				profile.re_search[1]++;
				fail_high=TRUE;

				score=-SearchPv(WHITE,-beta,-alpha,1,d,new_pv);
#ifdef	FULLDUMP
				printf("0 %02x%s%s(%02x) c=%s s=%d\n",To(move),koma[PIECE_TYPE(Piece(move))],Promote(move)?"":"",From(move),koma[PIECE_TYPE(Capture(move))],score);
#endif
			}
		}

		if ( AbortSearch ) break;	// Tfꂽ

		root_list[n].nodes=(profile.nodes-nodes_ini);
		root_list[n].max_ply=MaxPly;			// ő[̃Rs[
		root_list[n].max_qui_ply=MaxQuiPly;
		root_list[n].score=score;				// ^XRA
		PvAdd(root_list[n].pv,new_pv,move);		// őP̃Rs[

		if ( score > alpha ) {	// lXV
			alpha=score;
			root_list[n].cut_score=score;

			// XRAオ̂Ŏvl߂
			if ( score > (iterate_value[Iterate-1]-NO_EXTEND_MARGIN) ) Extend=FALSE;
		}
		else root_list[n].cut_score=DUNNO;	// JbgXRA
	}

	return alpha;
}


void
root_list_print()
/*------------------------------------------------------------------------
	Tʂ̕\
	߂l	Ȃ
		̐
		Tʂ̕\
		1/26/12	ŏ̃o[W
------------------------------------------------------------------------*/
{
int		n, break_cnt=0;

	lputs("                       cut   score   nodes ply qui");
	for ( n=0; n < min(3,root_n_move); n++ ) {	// 3̕\
	MOVE	move=root_move[n];

		if ( n && (root_list[n].nodes <= (profile.nodes/50)) ) continue;	// 98%̃m[h\

		if ( Reverse ) move=move_reverse(move);	// ]

		lprintf("%3d %02x%s%2s(%02x) c=%2s [%6d,%6d,%7d,%3d,%3d]\n",n+1,
			To(move),koma[PIECE_TYPE(Piece(move))],Promote(move)?"":"",From(move),koma[PIECE_ORG_TYPE(Capture(move))],
			root_list[n].cut_score,root_list[n].score,root_list[n].nodes,root_list[n].max_ply,root_list[n].max_qui_ply);

		PvPrint(root_list[n].pv);	// őP\
	}

	for ( n=3; n < root_n_move; n++ ) {		// XRA\
	MOVE	move=root_move[n];

		if ( Reverse ) move=move_reverse(move);	// ]

		lprintf("%3d %02x%s%2s(%02x) c=%2s [%6d,%6d,%7d,%3d,%3d]\n",n+1,
			To(move),koma[PIECE_TYPE(Piece(move))],Promote(move)?"":"",From(move),koma[PIECE_ORG_TYPE(Capture(move))],
			root_list[n].cut_score,root_list[n].score,root_list[n].nodes,root_list[n].max_ply,root_list[n].max_qui_ply);

		if ( (root_list[n].nodes <= (profile.nodes/50)) || (root_list[n].cut_score == DUNNO) ) {	// m[h1/2Jbgm[hȂ\I
			if ( break_cnt++ > 3 ) break;
		}
	}
	lputs("");

	lprintf("Elapsed:%d[ms] NPS:%lld\n",Elapsed,((profile.nodes+profile.qui_nodes)*1000LL)/it_time);
	lprintf("Node:%d PvNode:%d NonPvNode:%d QuiNode:%d\n",profile.nodes,profile.pv_nodes,profile.non_pv_nodes,profile.qui_nodes);
	lprintf("Reduction fail(PV):%d ZWS fail(PV):%d Reduction fail(NonPV):%d\n",profile.re_search[0],profile.re_search[1],profile.re_search[2]);
	lprintf("IID_pv:%d IID_nonpv:%d\n",profile.iid[0],profile.iid[1]);
	lprintf("Razoring:%.1lf(%d) Null move-prune:%.1lf(%d)\n",
		profile.razoring*100.0/profile.nodes,profile.razoring,profile.null_move*100.0/profile.nodes,profile.null_move);

	n=profile.lmr[0][0]+profile.lmr[0][1]+profile.lmr[0][2]+profile.lmr[0][3]+profile.lmr[0][4];
	if ( n ) {
		lprintf("LMR    PV 0:%.1lf(%d) 0.5:%.1lf(%d) 1:%.1lf(%d) 1.5:%.1lf(%d)\n",
			profile.lmr[0][0]*100.0/n,profile.lmr[0][0],
			profile.lmr[0][1]*100.0/n,profile.lmr[0][1],
			profile.lmr[0][2]*100.0/n,profile.lmr[0][2],
			profile.lmr[0][3]*100.0/n,profile.lmr[0][3]);
	}
	n=profile.lmr[1][0]+profile.lmr[1][1]+profile.lmr[1][2]+profile.lmr[1][3]+profile.lmr[1][4];
	if ( n ) {
		lprintf("LMR nonPV 0:%.1lf(%d) 0.5:%.1lf(%d) 1:%.1lf(%d) 1.5:%.1lf(%d) 2:%.1lf(%d)\n",
			profile.lmr[1][0]*100.0/n,profile.lmr[1][0],
			profile.lmr[1][1]*100.0/n,profile.lmr[1][1],
			profile.lmr[1][2]*100.0/n,profile.lmr[1][2],
			profile.lmr[1][3]*100.0/n,profile.lmr[1][3],
			profile.lmr[1][4]*100.0/n,profile.lmr[1][4]);
	}

	n=profile.pruning[0][0];		// PV
	if ( n ) {
		lprintf("PV Futility:%.1lf(%d)\n",
			profile.pruning[0][1]*100.0/n,profile.pruning[0][1]);
	}

	n=profile.pruning[1][0];		// nonPV
	if ( n ) {
		lprintf("nonPV Futility1:%.1lf(%d) Futility2:%.1lf(%d) NegaSee:%.1lf(%d) NegaCapPro:%.1lf(%d)\n",
			profile.pruning[1][1]*100.0/n,profile.pruning[1][1],
			profile.pruning[1][2]*100.0/n,profile.pruning[1][2],
			profile.pruning[1][3]*100.0/n,profile.pruning[1][3],
			profile.pruning[1][4]*100.0/n,profile.pruning[1][4]);
	}

	n=profile.pruning[2][0];		// Quiescence
	if ( n ) {
		lprintf("Quiescence Futility:%.1lf(%d) NegaSee:%.1lf(%d)\n",
			profile.pruning[2][1]*100.0/n,profile.pruning[2][1],
			profile.pruning[2][2]*100.0/n,profile.pruning[2][2]);
	}

	lprintf("Hash Use0:%d Use1:%d Use2:%d Collision:%d Used:%.1lf%% Hits:%.1lf%%\n",
		profile.hash_use[0],profile.hash_use[1],profile.hash_use[2],profile.hash_use[3],
		profile.hash_use[0]*100.0/(MAX_HASH_SIZE*REHASH_MAX),profile.hash_hits*100.0/(profile.hash_calls+1));

	if ( profile.eval_hash_use ) lprintf("EvalHashHits %.1lf%%(%d)\n",profile.eval_hash_hits*100.0/profile.eval_hash_use,profile.eval_hash_hits);
}


int
repetition(TRUNK *p)
/*------------------------------------------------------------------------
	/ۂ̃`FbN
	߂l	-INF/+INF	茟o
			-INF		یo
			0:Ȃ
		p	ǖʂ̃|C^
		ǖʂ4ȏ゠TRUE
		12/28/08	ŏ̃o[W
			1/30/12		ȈoOC
			4/26		ÎlύX
			5/1			ǖʉ񐔏C,AC
------------------------------------------------------------------------*/
{
int 	n, eval, count=0;

	for ( n=nMoves; n; n-- ) {
		if ( HashRecord[n] == p->hash_val ) {
			++count;
			if ( count >= 2 ) {		// ǖʂ3񂠂
				if ( CheckRecord[n] ) {	// Ă
					lputs("A");
					return -INF;
				}

				eval=Evalute(p);	// ݂̕]l߂

				if ( (Grade == OPENING) && (eval < -768) ) {		// 3
					lprintf("I[]:eval=%d\n",eval);
					return INF;
				}
				else if ( (Grade == MIDDLE) && (eval < -1100) ) {	// j
					lprintf("I[]:eval=%d\n",eval);
					return INF;
				}

				lprintf(":eval=%d\n",eval);
				return -INF;
			}
		}

		if ( BoardRecord[n] == p->board_hash ) {	// Ֆʓ
		int		m, num=0;

			for ( m=P_FU; m <= P_HISH; m++ ) num+=p->hand[BLACK][m];	// 𐔂
			if ( HandRecord[n] > num ) {
				lputs("یo");
				return -INF;	// Ă̂Ő
			}
		}
	}

	return 0;	// Ȃ
}


BOOL
entering_king()
/*------------------------------------------------------------------------
	ʏ̃`FbN
	߂l	TRUE	ʏ
		Ȃ
		27_@ɂʔ (http://www.computer-shogi.org/wcsc21/rule.html)
		1/18/11	ŏ̃o[W
------------------------------------------------------------------------*/
{
TRUNK	*p=Trunk+1;		// eǖʂ̃|C^
int		piece, n;
int		point=0, tekijin=0;

	if ( LOCATE_Y(p->king[BLACK]) > 3 ) return FALSE;	// ʂł͖

	for ( n=0; n < 81; n++ ) {	// ՂȂ߂
	int	pos=position_tbl[n];

		piece=p->board[pos];

		if ( piece & B_BIT ) {		// ̋𐔂
		int	t=PIECE_ORG_TYPE(piece);

			if ( (t >= P_FU) && (t <= P_KIN) ) point++;		// 
			else if ( (t == P_KAKU) || (t == P_HISH) ) point+=5;	// 

			if ( (LOCATE_Y(pos) <= 3) && t ) tekijin++;		// GwɗL
		}
	}

	if ( tekijin < 10 ) return FALSE;		// GwɗL10

	for ( n=P_FU; n <= P_KIN; n++ ) {		// ̓_
		point+=p->hand[BLACK][n];
	}
	for ( n=P_KAKU; n <= P_HISH; n++ ) {
		point+=(p->hand[BLACK][n]*5);
	}

	if ( Reverse ) {	// ł
		if ( point < 27 ) return FALSE;		// 27_
	}
	else {				// ł
		if ( point < 28 ) return FALSE;		// 28_
	}

	return TRUE;
}


void
sort(MOVE *p_move, struct ROOT_LIST *p_score, int n_move)
/*------------------------------------------------------------------------
	[g̕בւ
	߂l	Ȃ
		p_move	̃|C^
			p_score	̃XRÃ|C^
			n_move	̐
		XRAŕבւ,XRAȂm[ĥ
		2/24/10	ŏ̃o[W
------------------------------------------------------------------------*/
{
int	i, j;

	for ( i=0; i < n_move-1; i++ ) {
		for ( j=n_move-1; j > i; j-- ) {
			if ( (p_score[j-1].cut_score < p_score[j].cut_score) || ((p_score[j-1].cut_score == p_score[j].cut_score) && (p_score[j-1].nodes < p_score[j].nodes)) ) {
			MOVE				m;
			struct ROOT_LIST	rt;

				rt=p_score[j];		// ւ
				p_score[j]=p_score[j-1];
				p_score[j-1]=rt;

				m=p_move[j];			// ւ
				p_move[j]=p_move[j-1];
				p_move[j-1]=m;
			}
		}
	}
}
