/*
	\[X		search.c
	ȏ		PVm[h/PVm[hT
	CN[h
	IuWFNg	mss_usi
	ΉOS			Microsoft-Windows XP/Linux
	ΉCPU			Pentium4ȏ
	RpC		MinGW/gcc/icc
	vWFNg	Makefile
				mssvWFNg
				Oca
	a			Feb 18 2010/Dec 21 2008
*/

#ifdef	_WIN32
#include	<windows.h>
#endif
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<assert.h>
#include	"defines.h"
#include	"mss.h"

//#define	NO_RAZORING
//#define	NO_LMR
//#define	NO_FUTILITY
//#define	NO_EXTENSION

// Futility pruning̃}[W
#define	FUTILITY_MARGIN			640		// ȊÕ}[W (5)
#define	FUTILITY_MARGIN_KING	896		// ړ̃}[W (7)
#define	FUTILITY_MARGIN_PRE		64		// pre frontier nodẽ}[W (1/2)

int		HistoryCut[0xf99+1];			// Relative History Heuristic(cut)
int		HistoryTride[0xf99+1];			// Relative History Heuristic(tried)

static DWORD	start_time;				// vlJn
static int		remain_ply;				// c\z萔
static int		extension_time;			// 1艄


static void	clock();					// v
static int	diff(int turn, MOVE move, TRUNK *p);							// ]֐
static BOOL	threat_capture(int turn, TRUNK *old, TRUNK *new, MOVE move);	// f


int
SearchPv(int turn, int alpha, int beta, const int ply, const int depth, MOVE *pv)
/*------------------------------------------------------------------------
	PVm[hT
	߂l	]l
		turn		:1
			alpha, beta	,l
			ply			݂̓ǂݐ[
			depth		ő̐[(ONE_PLY/HALF_PLYP)
		nega-max@ŒT
		12/28/08	ŏ̃o[W
			12/04/09	nbV̉(EChE߂,[nbV̗̍p)
			12/05		History Heuristicǉ
			12/08		nbṼoOC
			12/09		σx[^Jbg̒ǉ(I[_O̐xw)
			12/14		[g̃XRÃNA
			12/31		Null-move Pruning
			01/02/10	PVS֕ύX
			01/03		ǖ,̃obt@[ʔzɂ
			01/07		Internal Iterative deepening
			01/10		[ł̃nbVL^͂߂
			01/11		m[h^Cvǉ,NMP,IIDׂ̍C
						nbV̎gC
			01/03/11	PV/NonPV֐ʂɂ
			01/12/11	LMRǉ
			02/02		ǉ
			02/11		depthPʕύX
			01/18/12	JbgȊÕqXg[ǉ
			01/20		G̑łƂɑłqXg[ǉ
			1/27		őP1z֕ύX
			03/04		Quiescence[vŌĂ([m[hĂ΂Ȃ)
			04/08		Relative History HeuristicɂLMR
			04/21		PVm[hłFutility pruning̗p
------------------------------------------------------------------------*/
{
TRUNK	*p=Trunk+ply;			// eǖʂ̃|C^
TRUNK	*copy=Trunk+ply+1;		// qǖʂ̃|C^

int		n, n_move, n_tried=0, score, ret=-INF;
int		init_alpha=alpha;
int		d, ext, reduce;
int		present;				// ǖʂ̕]l
BOOL	check;					// tO
MOVE	p_move[MAX_MOVE];		// ̔z
MOVE	move_tried[MAX_MOVE];	// qXg[ۑp
MOVE	best_mov=0;				// őP
MOVE	new_pv[MAX_PLY+1];		// őP̔z
HASH	*h;						// nbṼ|C^

	assert(depth >= 0);

	profile.nodes++;		// m[hJEg
	profile.pv_nodes++;

	PvClear(pv);		// őP̃NA
	PvClear(new_pv);

	clock();			// v

	if ( AbortSearch ) return 0;		// Tfꂽ

	if ( ply > MaxPly ) MaxPly=ply;		// ő[

	if ( ply >= (MAX_PLY-1) ) {		// ő̓ǂݐ[ɒB
		score=Evalute(p);
		return turn ? score : -score;
	}

	// *** Mate distance pruning
	alpha=max(-INF+ply,alpha);
	beta=min(INF-(ply+1),beta);
	if ( alpha >= beta ) return alpha;	// 肵Ă

	p->hash_move=0;		// nbV̎̃NA

	// *** nbṼXRA߂
	if ( (h=HashProbe(turn,p)) != NULL ) {
		if ( ((h->depth >= depth) && (HASH_TYPE(h->type_age) == EXACTLY)) ) {	// ^lȂ̂Ŏg
		MOVE move=p->hash_move;

			HashRefresh(h);		// nbVSearchAgeXV

			score=h->score;

			if ( (score >= beta) && move && !CapturePromote(move) && (KillerMove1[ply] != move) ) {	// L[̍XV
				KillerMove2[ply]=KillerMove1[ply];	// Jグ
				KillerMove1[ply]=move;
			}

			return score;		// nbṼXRAg
		}
	}

	if ( ply < (MAX_PLY-2) ) {		// L[̃NA
		KillerMove1[ply+2]=KillerMove2[ply+2]=0;
	}

	present=Evalute(p);						// ǖʂ̕]l߂Ă
	if ( !turn ) present=-present;			// ԑ猩]lɂĂ

	// *** Internal Iterative Deepening
	// nbV̎肪Αd[(nonPV)
	if ( (depth >= 3*ONE_PLY) && !p->hash_move ) {
		SearchPv(turn,alpha,beta,ply,depth-2*ONE_PLY,new_pv);	// 2󂭌
		profile.iid[0]++;
	}

	check=p->attack[turn^1][p->king[turn]];	// Ă

	n_move=GenerateOrder(turn,ply,p_move);	// ̐

	if ( check && !n_move ) return -INF+ply;	// l݂܂

	for ( n=0; !AbortSearch && (n < n_move); n++ ) {
	MOVE	move=p_move[n];

		if ( move == 0 ) continue;		// ꂽ

		*copy=*p;						// ǖʃRs[
		copy->current_mov=move;			// ̃Rs[
		NewBoard(turn,move,copy);		// ŐVǖʂ

		if ( copy->attack[turn][copy->king[turn^1]] ) {	// Ă
			if ( (From(move) == 0) && (Piece(move) == P_FU) ) {	// łl߂̃`FbN
				if ( DropFuMate(turn^1,copy) ) {	// łl
//					lprintf("łl\n");
//					MovePrint(p_move+n,1,NULL);

					continue;
				}
			}
			move|=ONEPLY_BIT;	// 1艄
		}

		ext=reduce=0;
#ifndef	NO_EXTENSION
		// *** T
		if ( ply < Iterate*3 ) {	// Iterate*3[ł͉Ȃ
			if ( ply >= Iterate*2 ) {	// Iterate*2ł͔艄Ɍ
				if ( move & (ONEPLY_BIT | HALFPLY_BIT) ) ext+=HALF_PLY;	// 0.5艄
			}
			else {
				if ( move & ONEPLY_BIT ) ext+=ONE_PLY;		// 1艄
				else if ( move & HALFPLY_BIT ) ext+=HALF_PLY;	// 0.5艄
			}
		}
#endif
		d=depth-ONE_PLY+ext;		// ̒Tւ̎c[

		if ( !CapturePromote(move) ) move_tried[n_tried++]=Move(move);	// T̕ۑ

#ifndef	NO_FUTILITY
		// *** Futility pruning
		if ( (d <= 1*ONE_PLY) && !check && !(move & (EXTENSION_BIT | KILLER_BIT)) ) {	// c[1
			profile.pruning[0][0]++;	// s

			if ( n >= 5 ) {		// ʂ̎͊Ȃ
				if ( (present+diff(turn,move,p)) <= alpha ) {	// }
					profile.pruning[0][1]++;

					continue;
				}
			}
		}
#endif

		if ( n == 0 ) {		// PVS
			score=(d < ONE_PLY) ? -Quiescence(turn^1,-beta,-alpha,ply+1,0) :
				-SearchPv(turn^1,-beta,-alpha,ply+1,d,new_pv);	// PVT
#ifdef	FULLDUMP
			printf("%*d %d %02x%s%s(%02x) c=%s s=%d (p0)\n",ply*2,ply,d,To(move),koma[PIECE_TYPE(Piece(move))],
				Promote(move)?"":"",From(move),koma[PIECE_ORG_TYPE(Capture(move))],score);
#endif
		}
		else {
#ifndef	NO_LMR		// *** Late-move Reduction (by Relative History Heuristic)
			if ( (d >= ONE_PLY) && !check && !(move & (ONEPLY_BIT | KILLER_BIT)) && !CapturePromote(move) ) {
			int	index=(move>>8) & 0xfff;
			int	cut=HistoryCut[index], tride=HistoryTride[index];
			int	dd;

				if ( cut*20 < tride ) {			// (0.05) 1.5
					reduce=(ONE_PLY*3)/2;
					profile.lmr[0][3]++;
				}
				else if ( cut*6 < tride ) {		// (0.167) 1
					reduce=ONE_PLY;
					profile.lmr[0][2]++;
				}
				else if ( (cut*9)/4 < tride ) {	// (0.444) 0.5
					reduce=ONE_PLY/2;
					profile.lmr[0][1]++;
				}
				else profile.lmr[0][0]++;

				dd=d-reduce;

				score=(dd < ONE_PLY) ? -Quiescence(turn^1,-alpha-1,-alpha,ply+1,0) :	// ZWS
					-SearchNonPv(turn^1,-alpha,ply+1,dd,TRUE,new_pv);
			}
			else score=alpha+1;

			if ( score > alpha ) {	// PVS̎cZWS/alphaXV̂ߒʏ[ZWS
#endif
				score=(d < ONE_PLY) ? -Quiescence(turn^1,-alpha-1,-alpha,ply+1,0) :
					-SearchNonPv(turn^1,-alpha,ply+1,d,TRUE,new_pv);

					if ( reduce ) profile.re_search[0]++;
#ifdef	FULLDUMP
				printf("%*d %d %02x%s%s(%02x) c=%s s=%d (p1)\n",ply*2,ply,d,To(move),koma[PIECE_TYPE(Piece(move))],
					Promote(move)?"":"",From(move),koma[PIECE_ORG_TYPE(Capture(move))],score);
#endif

#ifdef	NO_LMR
				if ( score > alpha ) {	// ZWSŝ߃EChE߂čĒT
#else
				if ( score > alpha && ((score < beta) || reduce) ) {	// ZWSŝ߃EChE߂čĒT(LMR͕]lsm)
#endif
					score=(d < ONE_PLY) ? -Quiescence(turn^1,-beta,-alpha,ply+1,0) :
						-SearchPv(turn^1,-beta,-alpha,ply+1,d,new_pv);

#ifdef	FULLDUMP
					printf("%*d %d %02x%s%s(%02x) c=%s s=%d (p1r)\n",ply*2,ply,d,To(move),koma[PIECE_TYPE(Piece(move))],
						Promote(move)?"":"",From(move),koma[PIECE_ORG_TYPE(Capture(move))],score);
#endif
					profile.re_search[1]++;
				}
#ifndef	NO_LMR
			}
#endif
		}

		if ( score > ret ) {	// xXglXV
			ret=score;
			if ( score > alpha ) {	// lXV
				best_mov=Move(move);
				PvAdd(pv,new_pv,best_mov);	// őP̃Rs[

				if ( score >= beta ) {		// Jbg
					profile.avg_cut[0][ply]=(profile.avg_cut[0][ply]+n*10)/2;	// σx[^Jbg
					break;
				}

				alpha=score;
			}
		}
	}

#if	(DEBUG >= 2)
	lprintf("%*s%d\n",ply*2+2,"ret=",ret);
#endif

	if ( AbortSearch ) return ret;	// Tfꂽ(nbVɒlĂ͂ȂȂ)

	if ( ret <= init_alpha ) {		// lXVĂȂ̂ŏl
		HashStore(turn,p,UPPERBOUND,depth,ret,0);	// nbVXRA̍XV(nbV͖̎)
	}
	else {
		if ( ret >= beta ) {		// Jbgꂽ̂ŉl
			HashStore(turn,p,LOWERBOUND,depth,ret,best_mov);	// nbVƃXRA̍XV

			if ( (INF-(ply+1)) == ret ) {	// killer mate̕ۑ
				KillerMate[ply]=best_mov;
			}
			// L[/History Heuristic̕ۑ
			else if ( !CapturePromote(best_mov) ) {	// 萬͏O
			int	n, d2;

				if ( KillerMove1[ply] != best_mov ) {	// L[̍XV
					KillerMove2[ply]=KillerMove1[ply];	// Jグ
					KillerMove1[ply]=best_mov;
				}

				d2=depth*depth;

				for ( n=0; n < n_tried; n++ ) {	// qXg[̍XV
					HistoryTride[(move_tried[n]>>8) & 0xfff]+=d2;
				}

				HistoryCut[(best_mov>>8) & 0xfff]+=d2;
			}
		}
		else {		// lXVȂ̂Ő^l
			HashStore(turn,p,EXACTLY,depth,ret,best_mov);	// nbVƃXRA̍XV
		}
	}

	return ret;
}


int
SearchNonPv(int turn, int beta, const int ply, const int depth, BOOL do_null, MOVE *pv)
/*------------------------------------------------------------------------
	PVm[hT
	߂l	]l
		turn		:1
			beta		l
			ply			݂̓ǂݐ[
			depth		ő̐[(ONE_PLY/HALF_PLYP)
			do_null		null-move prunings
		[T
		1/03/11		Pvs菑
			01/12/11	LMRǉ
			01/14/11	profile.ilityǉ
			02/02		ǉ
			02/11		depthPʕύX
			01/18/12	JbgȊÕqXg[ǉ
			01/20		G̑łƂɑłqXg[ǉ
			1/27		őP1z֕ύX
			03/04		Quiescence[vŌĂ([m[hĂ΂Ȃ)
			03/20		Razoringǉ
			04/08		Relative History HeuristicɂLMR
------------------------------------------------------------------------*/
{
TRUNK	*p=Trunk+ply;			// eǖʂ̃|C^
TRUNK	*copy=Trunk+ply+1;		// qǖʂ̃|C^

int		n, n_move, n_tried=0, score, ret=-INF;
int		d, ext, reduce;
int		present;				// ǖʂ̕]l
BOOL	check;					// tO
BOOL	threatmate=FALSE;		// l߂댟o
MOVE	p_move[MAX_MOVE];		// ̔z
MOVE	move_tried[MAX_MOVE];	// qXg[ۑp
MOVE	best_mov=0;				// őP
MOVE	new_pv[MAX_PLY+1];		// őP̔z
HASH	*h;						// nbṼ|C^

	assert(depth >= 0);
	assert(!p->attack[turn][p->king[turn^1]]);	// û͂

	profile.nodes++;		// m[hJEg
	profile.non_pv_nodes++;

	PvClear(pv);			// őP̃NA
	PvClear(new_pv);

	clock();				// v

	if ( AbortSearch ) return 0;		// Tfꂽ

	if ( ply > MaxPly ) MaxPly=ply;		// ő[

	if ( ply >= (MAX_PLY-1) ) {		// ő̓ǂݐ[ɒB
		score=Evalute(p);
		return turn ? score : -score;
	}

	// *** Mate distance pruning
	if ( (-INF+ply) >= beta ) return beta;		// 
	if ( (INF-(ply+1)) < beta ) return beta-1;	// 

	p->hash_move=0;		// nbV̎̃NA

	// *** nbṼXRA߂
	if ( (h=HashProbe(turn,p)) != NULL ) {
	int	type=HASH_TYPE(h->type_age);

		score=h->score;

		if ( (h->depth >= depth) || (score >= max((INF-100),beta)) || (score < min((-INF+100),beta)) ) {
			if ( ((type & LOWERBOUND) && (score >= beta)) || ((type & UPPERBOUND) && (score < beta)) ) {
			MOVE move=p->hash_move;

				HashRefresh(h);		// nbVSearchAgeXV

				if ( (score >= beta) && move && !CapturePromote(move) && (KillerMove1[ply] != move) ) {	// L[̍XV
					KillerMove2[ply]=KillerMove1[ply];	// Jグ
					KillerMove1[ply]=move;
				}

				return score;	// nbṼXRAg
			}
		}
	}

	if ( ply < (MAX_PLY-2) ) {		// L[̃NA
		KillerMove1[ply+2]=KillerMove2[ply+2]=0;
	}

	present=Evalute(p);						// ǖʂ̕]l߂Ă
	if ( !turn ) present=-present;			// ԑ猩]lɂĂ

	check=p->attack[turn^1][p->king[turn]];		// Ă

#ifndef	NO_RAZORING
	// *** Hyat Razoring Prune (http://www.talkchess.com/forum/viewtopic.php?t=41597)
	// c[3ȉ,肪2ȏ,nbVɎ肪͐Î~TĂяoďI
	if ( (depth <= 3*ONE_PLY) && !check && !p->hash_move && (beta > (present+512+depth*32))
		&& (abs(beta) < (INF-100)) ) {
	int	razor_beta=beta-512-depth*32;

		profile.razoring++;

		*copy=*p;				// ÔߋǖʃRs[g
		score=Quiescence(turn,razor_beta-1,razor_beta,ply+1,0);

		if ( score < razor_beta ) return score;
	}
#endif

	// *** Null-move Pruning
	// c[2ȏ,̋ǖʂł͖
	if ( (depth >= 2*ONE_PLY) && do_null && !check && (present >= beta) ) {
		d=depth-((depth < 6*ONE_PLY) ? 2*ONE_PLY : 4*ONE_PLY);	// 2󂭓ǂ,c肪[Ƃ4󂭓ǂ

		*copy=*p;				// ǖʃRs[
		copy->current_mov=0;	// null̃Rs[

		d-=ONE_PLY;				// ̒T֎c[-1
		score=(d < ONE_PLY) ? -Quiescence(turn^1,-beta-1,-beta,ply+1,0) :
			-SearchNonPv(turn^1,-beta+1,ply+1,d,FALSE,new_pv);

		if ( score >= beta ) {		// }
			profile.null_move++;

			return beta;		// 󂭓ǂ񂾂̂score͎gȂ
		}

		if ( score < (-INF+100) ) {		// l߂댟o
			threatmate=TRUE;
//			puts("l߂댟o");
		}
	}

	// *** Internal Iterative Deepening
	// nbV̎肪Αd[(nonPV)
	if ( (depth >= 5*ONE_PLY) && !p->hash_move && !check && ((present+512) > beta) ) {
		SearchNonPv(turn,beta,ply,depth/2,FALSE,new_pv);	// c蔼̐[Ō
		profile.iid[1]++;
	}

	n_move=GenerateOrder(turn,ply,p_move);	// ̐

	if ( check && !n_move ) return -INF+ply;	// l݂܂

//	threat_move=KillerMove1[ply+1];		// ̍D

	for ( n=0; !AbortSearch && (n < n_move); n++ ) {
	MOVE	move=p_move[n];

		if ( move == 0 ) continue;		// ꂽ

		*copy=*p;						// ǖʃRs[
		copy->current_mov=move;			// ̃Rs[
		NewBoard(turn,move,copy);		// ŐVǖʂ

		if ( copy->attack[turn][copy->king[turn^1]] ) {	// Ă
			if ( (From(move) == 0) && (Piece(move) == P_FU) ) {	// łl߂̃`FbN
				if ( DropFuMate(turn^1,copy) ) {	// łl
//					lprintf("łl\n");
//					MovePrint(p_move+n,1,NULL);

					continue;
				}
			}
			move|=ONEPLY_BIT;	// 1艄
		}

		ext=reduce=0;
#ifndef	NO_EXTENSION
		// *** T
		if ( ply < Iterate*2 ) {	// Iterate*2[ł͉Ȃ
			if ( ply >= ((Iterate*3)/2) ) {		// Iterate*1.5ł͔艄Ɍ
				if ( move & (ONEPLY_BIT | HALFPLY_BIT) ) ext+=HALF_PLY;	// 0.5艄
			}
			else {
				if ( move & ONEPLY_BIT ) ext+=ONE_PLY;		// 1艄
				else if ( move & HALFPLY_BIT ) ext+=HALF_PLY;	// 0.5艄
			}
		}
#endif
		d=depth-ONE_PLY+ext;		// ̒Tւ̎c[

		if ( !CapturePromote(move) ) move_tried[n_tried++]=Move(move);	// T̕ۑ

#ifndef	NO_LMR		// *** Late-move Reduction (by Relative History Heuristic)
		if ( (depth >= ONE_PLY) && !threatmate && !check && !(move & (ONEPLY_BIT | KILLER_BIT)) && !CapturePromote(move) ) {
		int	index=(move>>8) & 0xfff;
		int	cut=HistoryCut[index], tride=HistoryTride[index];

			if ( cut*10 < tride ) {			// (0.1) 2
				reduce=ONE_PLY*2;
				profile.lmr[1][4]++;
			}
			else if ( cut*6 < tride ) {		// (0.167) 1.5
				reduce=(ONE_PLY*3)/2;
				profile.lmr[1][3]++;
			}
			else if ( cut*4 < tride ) {		// (0.25) 1
				reduce=ONE_PLY;
				profile.lmr[1][2]++;
			}
			else if ( (cut*3)/2 < tride ) {	// (0.667) 0.5
				reduce=ONE_PLY/2;
				profile.lmr[1][1]++;
			}
			else profile.lmr[1][0]++;
		}
#endif

		d-=reduce;

#ifndef	NO_FUTILITY
		if ( (d <= 2*ONE_PLY) && !check && !(move & (ONEPLY_BIT | KILLER_BIT)) && !threatmate ) {
			profile.pruning[1][0]++;	// s

			// *** Futility pruning
			if ( d <= 1*ONE_PLY ) {			// c[1
				if ( (present+diff(turn,move,p)) <= beta ) {	// }
					profile.pruning[1][1]++;

					continue;
				}
			}
			else if ( d <= 2*ONE_PLY ) {	// c[2
				if ( (present+diff(turn,move,p)+FUTILITY_MARGIN_PRE) <= beta ) {	// }
					profile.pruning[1][2]++;

					continue;
				}
			}

			// *** ǂ݂̐[Ƃł̋̂Ă͎}
			if ( !CapturePromote(move) ) {
				if ( copy->attack[turn^1][To(move)] && (See(To(move),copy) < 0) ) {
					profile.pruning[1][3]++;

					continue;
				}
			}

			// *** ǂ݂̐[Ƃł̋͎}
			if ( CapturePromote(move) && (move & PRUNING_BIT) ) {
				profile.pruning[1][4]++;

				continue;
			}
		}
#endif

		score=(d < ONE_PLY) ? -Quiescence(turn^1,-beta-1,-beta,ply+1,0) :
			-SearchNonPv(turn^1,-beta+1,ply+1,d,TRUE,new_pv);				// ZWS

#ifdef	FULLDUMP
		printf("%*d %d %02x%s%s(%02x) c=%s s=%d (n)\n",ply*2,ply,d,To(move),koma[PIECE_TYPE(Piece(move))],
			Promote(move)?"":"",From(move),koma[PIECE_ORG_TYPE(Capture(move))],score);
#endif

#ifndef	NO_LMR		// *** Late-move Reduction
		if ( (score >= beta) && reduce ) {	// beta cut̂Ő[߂ZWS
			// ʏ[ZWS
			d+=reduce;
			score=(d < ONE_PLY) ? -Quiescence(turn^1,-beta-1,-beta,ply+1,0):
				-SearchNonPv(turn^1,-beta+1,ply+1,d,TRUE,new_pv);

			profile.re_search[2]++;
		}
#endif

		if ( score > ret ) {	// xXglXV
			ret=score;
			if ( score >= beta ) {		// Jbg
				best_mov=Move(move);
				PvAdd(pv,new_pv,best_mov);	// őP̒ǉ
				profile.avg_cut[1][ply]=(profile.avg_cut[1][ply]+n*10)/2;	// σx[^Jbg
				break;
			}
		}
	}

#if	(DEBUG >= 2)
	lprintf("%*s%d\n",ply*2+2,"ret=",ret);
#endif

	if ( AbortSearch ) return ret;	// Tfꂽ(nbVɒlĂ͂ȂȂ)

	if ( ret < beta ) {		// xXglXVȂ̂ŏl
		HashStore(turn,p,UPPERBOUND,depth,ret,0);	// nbVXRA̍XV(nbV͖̎)
	}
	else {		// Jbgꂽ̂ŉl
		HashStore(turn,p,LOWERBOUND,depth,ret,best_mov);	// nbVƃXRA̍XV

		if ( (INF-(ply+1)) == ret ) {	// killer mate̕ۑ
			KillerMate[ply]=best_mov;
		}
		// L[/History Heuristic̕ۑ
		else if ( !CapturePromote(best_mov) ) {	// 萬͏O
		int	n, d2;

			if ( KillerMove1[ply] != best_mov ) {		// L[̍XV
				KillerMove2[ply]=KillerMove1[ply];	// Jグ
				KillerMove1[ply]=best_mov;
			}

			d2=depth*depth;

			for ( n=0; n < n_tried; n++ ) {	// qXg[̍XV
				HistoryTride[(move_tried[n]>>8) & 0xfff]+=d2;
			}

			HistoryCut[(best_mov>>8) & 0xfff]+=d2;
		}
	}

	return ret;
}


void
CalcTime()
/*------------------------------------------------------------------------
	c莞Ԃ̌vZ
	߂l	Ȃ
		Ȃ
		c莞Ԃ̌vZ,
		4/28/12	ŏ̃o[W
			4/29	c莞ԂȂƂ11bɂ
------------------------------------------------------------------------*/
{
#define	ESTIMATE_MAX_PLY		200		// \z萔

	start_time=GetTickCount();			// vZbg
	Elapsed=0;

	switch ( Grade ) {				// isxɂĎvlԂς(IՂقǒǂ)
		case OPENING:	// 
			remain_ply=max((ESTIMATE_MAX_PLY-nMoves)/2,80);
			OnePlyTime=max(RemainTime/remain_ply,1000);	// c莞Ԃ킸Ȃ؂ꕉɂȂ邾낤
			extension_time=OnePlyTime;
			break;
		case MIDDLE:	// 
			remain_ply=max((ESTIMATE_MAX_PLY-nMoves)/2,40);
			OnePlyTime=max(RemainTime/remain_ply,1000);
			extension_time=OnePlyTime*2;
			break;
		case ENDING:	// I
			remain_ply=max((ESTIMATE_MAX_PLY-nMoves)/2,20);
			OnePlyTime=max(RemainTime/remain_ply,1000);
			extension_time=OnePlyTime*3;
			break;
	}

	lprintf("AnalyzeMode=%d RemainPly=%d RemainTime=%d Countdown=%d OnePlyTime=%d extension_time=%d\n",
		AnalyzeMode,remain_ply,RemainTime,Countdown,OnePlyTime,extension_time);
}


void
ResetClock()
/*------------------------------------------------------------------------
	v߂
	߂l	Ȃ
		Ȃ
		c莞Ԃ̏
		4/28/12	ŏ̃o[W
------------------------------------------------------------------------*/
{
	start_time=GetTickCount();			// vZbg
	Elapsed=0;

}


void
clock()
/*------------------------------------------------------------------------
	v
	߂l	Ȃ
		Ȃ
		ԊǗXbh
		4/28/12	ŏ̃o[W
------------------------------------------------------------------------*/
{
	Elapsed=(GetTickCount()-start_time);	// oߎ

	if ( AnalyzeMode ) return;		// /\[h

	// ʏvl
	if ( RemainTime ) {		// c莞
		if ( (Elapsed+700) >= (OnePlyTime+(Extend ? extension_time:0)) ) {	// 0.7bO܂
			AbortSearch=TRUE;
		}
	}
	if ( Countdown ) {		// bǂ
		if ( (Elapsed+((Countdown < 10000) ? 500 : 700)) >= Countdown ) {	// 0.5 or 0.7bO܂
			AbortSearch=TRUE;
		}
	}
}


int
diff(int turn, MOVE move, TRUNK *p)
/*------------------------------------------------------------------------
	]֐
	߂l	Ȃ
		turn	:1
			p		ǖʂ̃|C^
		+肾Ԃ
		1/03/11 VK쐬
			3/11	őȂ_
			4/17/12	̍vZ
			4/21	ʒu̕]l͋߂Ȃ(}[Wőp)
------------------------------------------------------------------------*/
{
int		piece=Piece(move);
int		v=0;

	if ( From(move) ) {		// ړ
	int		capture=Capture(move);

		if ( capture ) {		// 
			assert(capture != P_OU);	// 邱Ƃ͖

			v+=piece_value[capture];
		}

		if ( piece == P_OU ) {
			return FUTILITY_MARGIN_KING+v;	// ړ̍l
		}

		if ( Promote(move) ) {	// 
			v+=promote_value[piece];
		}

	}

	return FUTILITY_MARGIN+v;		// ȊO̎
}


BOOL
threat_capture(int turn, TRUNK *old, TRUNK *new, MOVE move)
/*------------------------------------------------------------------------
	f
	߂l	f
		turn		:1
			old			ǖ
			new			iǖ
			move		
		ї󂯂Ă
			їω̋
		3/29/12		VK쐬
------------------------------------------------------------------------*/
{
int		*board=new->board;
int		to=To(move);
int		from=From(move);
int		*new_attack=new->attack[turn^1];
int		*old_attack=old->attack[turn^1];
int		n, bit=turn ? W_BIT : B_BIT;

	if ( !((old_attack[from]>>TOBI_SHFT) & TOBI_MASK) ) return FALSE;	// ї󂯂ĂȂ

	for ( n=0; n < 81; n++ ) {	// ՂȂ߂
	int	pos=position_tbl[n];

		if ( (board[pos] & bit) && (pos != from) && (pos != to) &&
			((old_attack[pos]>>TOBI_SHFT) ^ (new_attack[pos]>>TOBI_SHFT)) ) {	// їω
		}
	}
}
