/*
	\[X		usi.c
	ȏ		USI[`
	CN[h
	IuWFNg	mss_usi
	ΉOS			Microsoft-Windows XP/Linux
	ΉCPU			Pentium4ȏ
	RpC		MinGW/gcc/icc
	vWFNg	Makefile
				mssvWFNg
				Oca
	a			Feb 18 2010/Dec 21 2008
*/

#ifdef	_WIN32
#include	<windows.h>
#include	<process.h>
#else
#include	<pthread.h>
#include	<unistd.h>
#endif
#include	<stdio.h>
#include	<stdlib.h>
#ifdef	_WIN32
#include	<io.h>
#else
#include	<unistd.h>
#endif
#include	<time.h>
#include	<string.h>
#include	<stdarg.h>
#include	"defines.h"
#include	"mss.h"


#define	LINE_SIZE	10000		// ő1s

static volatile BOOL	go=FALSE;	// goR}h
static char	go_line[80];		// goR}hs
static int	ret_val;			// vl̖߂l
static int	games=0;			// Q[
static MOVE	bestmove[2];		// őP/\z
static BOOL	complete;			// vl
static BOOL	ponder;				// \zǂݒ
static FILE	*fp_usi_log;		// USIOp

static void	open_usi_log();		// USIOt@C̃I[v

#ifdef	_WIN32
static void	usi_get(void *arg);		// USIR}hMXbh
#else
static void	*usi_get(void *arg);
#endif
static void	send_move();	// Ԃ


int
main(int argc, char **argv)
/*------------------------------------------------------------------------
	C
		낢
			USIR}hMXbhN
		12/21/10	ŏ̃o[W
		09/06/11	O̓ftHgOFF
------------------------------------------------------------------------*/
{
#ifndef	_WIN32
pthread_t		thread;
#endif

	setbuf(stdin,NULL);
	setbuf(stdout,NULL);	// stdoutobt@

	// mss.confǂݍ
	log_enable=GetConfInt("log_enable",0,CONF_FILE);
	usi_dump=GetConfInt("usi_dump",0,CONF_FILE);
	no_book=GetConfInt("no_book",0,CONF_FILE);
	random_book=GetConfInt("random_book",0,CONF_FILE);
	pondering=GetConfInt("pondering",0,CONF_FILE);

	if ( log_enable ) {		// Ot@C̃I[v
		open_log();
	}
	if ( usi_dump ) {		// USIOt@C̃I[v
		open_usi_log();
	}

	lprintf("<<< MiyakoShogiSystem v.%s Kyoto Japan >>>\n",version);
	lputs("*** options");
	lprintf("no_book=%d\n",no_book);
	lprintf("random_book=%d\n",random_book);
	lprintf("pondering=%d\n\n",pondering);

	HashInit();					// nbVL[̏
	InitEvalute(READ_WEIGHT);	// ]֐̏

#ifdef	_WIN32
	_beginthread(usi_get,0,NULL);	// USIR}hMXbh
#else
	pthread_create(&thread,NULL,usi_get,NULL);
#endif

	for (;;) {
		if ( go ) {					// *** vlJn
		char	*p;
		int		b_time=0, w_time=0;

			complete=ponder=FALSE;

			if ( !strncmp("ponder",go_line+3,5) ) {		// \ǂ݊Jn
				AnalyzeMode=TRUE;
				ponder=TRUE;

				lputs("--------------------------------------------------------------------------");
				lprintf("\ǂ݊Jn \%s ",Reverse ? "":"");
				MovePrint(bestmove+1,1,NULL);
			}
			else if ( !strncmp("infinite",go_line+3,8) ) {	// [h
				AnalyzeMode=TRUE;
			}
			else {
				AnalyzeMode=FALSE;		// ʏ탂[h
				Countdown=0;
			}

			// Ԃ̃p[X
			if ( (p=strstr(go_line,"btime")) ) {	// ̎
				b_time=atoi(p+6);
			}
			if ( (p=strstr(go_line,"wtime")) ) {	// ̎
				w_time=atoi(p+6);
			}
			RemainTime=(Reverse) ? w_time : b_time;

			if ( (p=strstr(go_line,"byoyomi")) ) {	// bǂ
				Countdown=atoi(p+8);
			}

			// Ԃ̐ݒ肪Ȃ110bɂĂ
			if ( (RemainTime == 0) && (Countdown == 0) ) Countdown=10000;

			bestmove[0]=bestmove[1]=0;
			ret_val=Think(bestmove,MAX_PLY);	// ̎l

			complete=TRUE;					// vl
			if ( !ponder ) {	// ʏvlȂ̂ŎԂ
				send_move();
			}

			go=FALSE;
		}
		else Sleep(10);
	}

	return 0;
}


void
send_move()
/*------------------------------------------------------------------------
	Ԃ
	߂l	Ȃ
		Ȃ
	
		12/19/11 ŏ̃o[W
------------------------------------------------------------------------*/
{
	if ( ret_val == 0 ) {
		usi_printf("bestmove resign\n");		// 
	}
	else if ( ret_val == -5 ) {
		usi_printf("bestmove win\n");		// ʏ
	}
	else {				// Ԃ
	char	s[16];
	MOVE	move;

		move=bestmove[0];
		if ( Reverse ) move=move_reverse(move);	// O㔽]
		move2usi(move,s);						// ϊ
		usi_printf("bestmove %s",s);			// Ԃ

		move=bestmove[1];	// \z
		if ( pondering && (move != PV_LAST) ) {		// \ǂ݂
			if ( Reverse ) move=move_reverse(move);	// O㔽]
			move2usi(move,s);						// ϊ
			usi_printf(" ponder %s",s);			// Ԃ
		}
		usi_printf("\n");
	}
	usi_flush();
}


#ifdef	_WIN32
void
#else
void *
#endif
usi_get(void *arg)
/*------------------------------------------------------------------------
	USIR}hMXbh
	߂l	Ȃ
		Ȃ
	
		12/31/10	ŏ̃o[W
			4/28/12		stopM,vl܂ő҂
------------------------------------------------------------------------*/
{
char	line[LINE_SIZE];

	while ( usi_gets(line) != NULL ) {		// 1sǂݍ
		if ( !strncmp("usi\n",line,4) ) {					// *** NmF
			usi_printf("id name mss v.%s\n",version);
			usi_printf("id author y.maeda\n");
			usi_printf("usiok\n");			// JnmF
			usi_flush();
		}
		else if ( !strncmp("isready\n",line,8) ) {			// *** ΋ǊJn
			// ̏
			HashClear();	// nbV\̏

			usi_printf("readyok\n");		// OK
			usi_flush();
		}
		else if ( !strncmp("usinewgame\n",line,11) ) {		// *** Q[Jn
			if ( games ) {		// N͂̂܂܃Op
				if ( log_enable ) {		// Ot@C̃I[v
					open_log();
				}
			}

			games++;
		}
		else if ( !strncmp("gameover",line,8) ) {			// *** Q[I
			AbortSearch=TRUE;		// T~

			if ( !strncmp("win",line+9,3) ) {
				lputs("win!");
			}
			else if ( !strncmp("lose",line+9,4) ) {
				lputs("lose");
			}
			else if ( !strncmp("draw",line+9,4) ) {
				lputs("draw");
			}
		}
		else if ( !strncmp("stop\n",line,5) ) {				// *** T~
			AbortSearch=TRUE;	// T~
			ponder=AnalyzeMode=FALSE;		// ʏvl

			if ( complete ) {	// vlȂ
				send_move();	// Ԃ
			}
			lputs(">>> Tf(stopM)");

			while ( !complete ) Sleep(10);	// vl܂ő҂
		}
		else if ( !strncmp("position",line,8) ) {			// *** ǖʂĂ
			nMoves=read_position(line+9);		// ǖʂ𓾂
		}
		else if ( !strncmp("go",line,2) ) {					// *** vlJn(C[vŏ)
			strcpy(go_line,line);
			go=TRUE;
		}
		else if ( !strncmp("ponderhit\n",line,10) ) {		// *** ʏvl֐؂ւ
			AnalyzeMode=FALSE;	// ʏvl
			ResetClock();		// v߂

			if ( complete ) {	// vlȂ
				send_move();	// Ԃ
			}
			else ponder=FALSE;	// ʏvl
			lputs("ponderhit");
		}
		else if ( !strncmp("quit\n",line,5) ) {				// *** I
			if ( log_enable ) fclose(fp_log);	// O
			if ( fp_usi_log != NULL ) fclose(fp_usi_log);	// USIO

			exit(0);
		}
	}

#ifndef	_WIN32
	return NULL;
#endif
}


void
usi_info(int t, int cp, MOVE *pv)
/*------------------------------------------------------------------------
	USI infoR}hM
	߂l	Ȃ
		t		(Ȃpv\=Վ)
			cp		XRA
	
		12/31/10 ŏ̃o[W
------------------------------------------------------------------------*/
{
int		n;
MOVE	move;

	if ( t > 0 ) {
		n=profile.nodes+profile.qui_nodes;
		usi_printf("info time %d depth %d nodes %d score cp %d ",t,Iterate,n,cp);
		usi_printf("hashfull %d nps %d pv ",(int)((profile.hash_use[0]*1000LL)/(MAX_HASH_SIZE*REHASH_MAX)),(int)((n*1000LL)/t));
	}
	else {
		usi_printf("info nodes %d pv ",cp);
	}

	for ( n=0; (n < MAX_PLY) && ((move=*pv++) != PV_LAST); n++ ) {
	char	s[6];

		if ( move == 0 ) break;		// NULL͕\f

		if ( Reverse ) move=move_reverse(move);	// t

		move2usi(move,s);	// moveusiϊ
		usi_printf("%s ",s);
	}
	usi_printf("\n");

	usi_flush();
}


void
open_usi_log()
/*------------------------------------------------------------------------
	USIOt@C̃I[v
	߂l	Ȃ
		Ȃ
		Ot@C̃I[v
			t@C_uƂ̓t@Cς
		2/23/11	ŏ̃o[W
------------------------------------------------------------------------*/
{
struct tm	*tp;
time_t 		t;
char		ts[16], logfile[32];

	t=time(NULL);
	tp=localtime(&t);
	sprintf(ts,"%02d%02d_%02d%02d",tp->tm_mon+1,tp->tm_mday,tp->tm_hour,tp->tm_min);	// 

	sprintf(logfile,"%s_usi.log",ts);	// Ot@C

#ifdef	_WIN32
	if ( !_access(logfile,0) ) {		// t@C݂邽߃t@Cς
#else
	if ( !access(logfile,F_OK) ) {
#endif
		sprintf(logfile,"%sa_usi.log",ts);	// Ot@C
	}

	if ( (fp_usi_log=fopen(logfile,"w")) == NULL ) {
		fprintf(stderr,"%s open error\n",logfile);
		return;
	}
	setbuf(fp_usi_log,NULL);		// OAobt@
}


int
usi_printf(const char *format, ...)
/*------------------------------------------------------------------------
	stdout֏o,USIO
	߂l	ڐ
		format	tH[}bg
		vfprintfĂяo
		12/01/10	ŏ̃o[W
------------------------------------------------------------------------*/
{
int		ret=0;
va_list	arg;

	va_start(arg,format);
	ret=vprintf(format,arg);
	va_end(arg);

	if ( fp_usi_log != NULL ) {
		va_start(arg,format);
		vfprintf(fp_usi_log,format,arg);
		va_end(arg);
	}

	return ret;
}


char *
usi_gets(char *s)
/*------------------------------------------------------------------------
	stdin1s,USIO
	߂l	ڐ
		format	tH[}bg
		fprintfĂяo
		12/01/10	ŏ̃o[W
------------------------------------------------------------------------*/
{
char	*p;

	p=fgets(s,LINE_SIZE-1,stdin);

	if ( fp_usi_log != NULL ) fprintf(fp_usi_log,"> %s",s);

	return p;
}
